# IO.Swagger.Api.AlertsApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**AlertsChangeGet**](AlertsApi.md#alertschangeget) | **GET** /alerts_change | Edit or insert new alert
[**AlertsDeleteGet**](AlertsApi.md#alertsdeleteget) | **GET** /alerts_delete | Permanently delete the alert
[**AlertsGet**](AlertsApi.md#alertsget) | **GET** /alerts | Get alerts for user account

<a name="alertschangeget"></a>
# **AlertsChangeGet**
> List<Domains> AlertsChangeGet (string id, string alertname, bool? activated, int? type, int? channel, string recipient, string param1 = null, string param2 = null, string param3 = null, string param4 = null, string param5 = null, string param6 = null)

Edit or insert new alert

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AlertsChangeGetExample
    {
        public void main()
        {

            var apiInstance = new AlertsApi();
            var id = id_example;  // string | ID of the alert to edit ; if adding a new one leave blank
            var alertname = alertname_example;  // string | Name of the alert
            var activated = true;  // bool? | Should the alert be activated or not
            var type = 56;  // int? | Alert type (1= New content for website, 2=New performing contents), 3=New contents in category
            var channel = 56;  // int? | 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON
            var recipient = recipient_example;  // string | Email address of recipient or webhook for Slack/Gchat or JSON endpoint
            var param1 = param1_example;  // string | Parameter 1 (meaning changes with alert type) (optional) 
            var param2 = param2_example;  // string | Parameter 2 (meaning changes with alert type) (optional) 
            var param3 = param3_example;  // string | Parameter 3 (meaning changes with alert type) (optional) 
            var param4 = param4_example;  // string | Parameter 4 (meaning changes with alert type) (optional) 
            var param5 = param5_example;  // string | Parameter 5 (meaning changes with alert type) (optional) 
            var param6 = param6_example;  // string | Parameter 6 (meaning changes with alert type) (optional) 

            try
            {
                // Edit or insert new alert
                List&lt;Domains&gt; result = apiInstance.AlertsChangeGet(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5, param6);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AlertsApi.AlertsChangeGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| ID of the alert to edit ; if adding a new one leave blank | 
 **alertname** | **string**| Name of the alert | 
 **activated** | **bool?**| Should the alert be activated or not | 
 **type** | **int?**| Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category | 
 **channel** | **int?**| 1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON | 
 **recipient** | **string**| Email address of recipient or webhook for Slack/Gchat or JSON endpoint | 
 **param1** | **string**| Parameter 1 (meaning changes with alert type) | [optional] 
 **param2** | **string**| Parameter 2 (meaning changes with alert type) | [optional] 
 **param3** | **string**| Parameter 3 (meaning changes with alert type) | [optional] 
 **param4** | **string**| Parameter 4 (meaning changes with alert type) | [optional] 
 **param5** | **string**| Parameter 5 (meaning changes with alert type) | [optional] 
 **param6** | **string**| Parameter 6 (meaning changes with alert type) | [optional] 

### Return type

[**List<Domains>**](Domains.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="alertsdeleteget"></a>
# **AlertsDeleteGet**
> List<TransactionInfo> AlertsDeleteGet (string id)

Permanently delete the alert

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AlertsDeleteGetExample
    {
        public void main()
        {

            var apiInstance = new AlertsApi();
            var id = id_example;  // string | alert id to delete

            try
            {
                // Permanently delete the alert
                List&lt;TransactionInfo&gt; result = apiInstance.AlertsDeleteGet(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AlertsApi.AlertsDeleteGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| alert id to delete | 

### Return type

[**List<TransactionInfo>**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
<a name="alertsget"></a>
# **AlertsGet**
> List<Alerts> AlertsGet ()

Get alerts for user account

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AlertsGetExample
    {
        public void main()
        {

            var apiInstance = new AlertsApi();

            try
            {
                // Get alerts for user account
                List&lt;Alerts&gt; result = apiInstance.AlertsGet();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AlertsApi.AlertsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**List<Alerts>**](Alerts.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
