/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IAlertsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Edit or insert new alert
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the alert to edit ; if adding a new one leave blank</param>
        /// <param name="alertname">Name of the alert</param>
        /// <param name="activated">Should the alert be activated or not</param>
        /// <param name="type">Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category</param>
        /// <param name="channel">1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON</param>
        /// <param name="recipient">Email address of recipient or webhook for Slack/Gchat or JSON endpoint</param>
        /// <param name="param1">Parameter 1 (meaning changes with alert type) (optional)</param>
        /// <param name="param2">Parameter 2 (meaning changes with alert type) (optional)</param>
        /// <param name="param3">Parameter 3 (meaning changes with alert type) (optional)</param>
        /// <param name="param4">Parameter 4 (meaning changes with alert type) (optional)</param>
        /// <param name="param5">Parameter 5 (meaning changes with alert type) (optional)</param>
        /// <param name="param6">Parameter 6 (meaning changes with alert type) (optional)</param>
        /// <returns>List&lt;Domains&gt;</returns>
        List<Domains> AlertsChangeGet (string id, string alertname, bool? activated, int? type, int? channel, string recipient, string param1 = null, string param2 = null, string param3 = null, string param4 = null, string param5 = null, string param6 = null);

        /// <summary>
        /// Edit or insert new alert
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the alert to edit ; if adding a new one leave blank</param>
        /// <param name="alertname">Name of the alert</param>
        /// <param name="activated">Should the alert be activated or not</param>
        /// <param name="type">Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category</param>
        /// <param name="channel">1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON</param>
        /// <param name="recipient">Email address of recipient or webhook for Slack/Gchat or JSON endpoint</param>
        /// <param name="param1">Parameter 1 (meaning changes with alert type) (optional)</param>
        /// <param name="param2">Parameter 2 (meaning changes with alert type) (optional)</param>
        /// <param name="param3">Parameter 3 (meaning changes with alert type) (optional)</param>
        /// <param name="param4">Parameter 4 (meaning changes with alert type) (optional)</param>
        /// <param name="param5">Parameter 5 (meaning changes with alert type) (optional)</param>
        /// <param name="param6">Parameter 6 (meaning changes with alert type) (optional)</param>
        /// <returns>ApiResponse of List&lt;Domains&gt;</returns>
        ApiResponse<List<Domains>> AlertsChangeGetWithHttpInfo (string id, string alertname, bool? activated, int? type, int? channel, string recipient, string param1 = null, string param2 = null, string param3 = null, string param4 = null, string param5 = null, string param6 = null);
        /// <summary>
        /// Permanently delete the alert
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">alert id to delete</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        List<TransactionInfo> AlertsDeleteGet (string id);

        /// <summary>
        /// Permanently delete the alert
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">alert id to delete</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        ApiResponse<List<TransactionInfo>> AlertsDeleteGetWithHttpInfo (string id);
        /// <summary>
        /// Get alerts for user account
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;Alerts&gt;</returns>
        List<Alerts> AlertsGet ();

        /// <summary>
        /// Get alerts for user account
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;Alerts&gt;</returns>
        ApiResponse<List<Alerts>> AlertsGetWithHttpInfo ();
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Edit or insert new alert
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the alert to edit ; if adding a new one leave blank</param>
        /// <param name="alertname">Name of the alert</param>
        /// <param name="activated">Should the alert be activated or not</param>
        /// <param name="type">Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category</param>
        /// <param name="channel">1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON</param>
        /// <param name="recipient">Email address of recipient or webhook for Slack/Gchat or JSON endpoint</param>
        /// <param name="param1">Parameter 1 (meaning changes with alert type) (optional)</param>
        /// <param name="param2">Parameter 2 (meaning changes with alert type) (optional)</param>
        /// <param name="param3">Parameter 3 (meaning changes with alert type) (optional)</param>
        /// <param name="param4">Parameter 4 (meaning changes with alert type) (optional)</param>
        /// <param name="param5">Parameter 5 (meaning changes with alert type) (optional)</param>
        /// <param name="param6">Parameter 6 (meaning changes with alert type) (optional)</param>
        /// <returns>Task of List&lt;Domains&gt;</returns>
        System.Threading.Tasks.Task<List<Domains>> AlertsChangeGetAsync (string id, string alertname, bool? activated, int? type, int? channel, string recipient, string param1 = null, string param2 = null, string param3 = null, string param4 = null, string param5 = null, string param6 = null);

        /// <summary>
        /// Edit or insert new alert
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the alert to edit ; if adding a new one leave blank</param>
        /// <param name="alertname">Name of the alert</param>
        /// <param name="activated">Should the alert be activated or not</param>
        /// <param name="type">Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category</param>
        /// <param name="channel">1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON</param>
        /// <param name="recipient">Email address of recipient or webhook for Slack/Gchat or JSON endpoint</param>
        /// <param name="param1">Parameter 1 (meaning changes with alert type) (optional)</param>
        /// <param name="param2">Parameter 2 (meaning changes with alert type) (optional)</param>
        /// <param name="param3">Parameter 3 (meaning changes with alert type) (optional)</param>
        /// <param name="param4">Parameter 4 (meaning changes with alert type) (optional)</param>
        /// <param name="param5">Parameter 5 (meaning changes with alert type) (optional)</param>
        /// <param name="param6">Parameter 6 (meaning changes with alert type) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Domains&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Domains>>> AlertsChangeGetAsyncWithHttpInfo (string id, string alertname, bool? activated, int? type, int? channel, string recipient, string param1 = null, string param2 = null, string param3 = null, string param4 = null, string param5 = null, string param6 = null);
        /// <summary>
        /// Permanently delete the alert
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">alert id to delete</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        System.Threading.Tasks.Task<List<TransactionInfo>> AlertsDeleteGetAsync (string id);

        /// <summary>
        /// Permanently delete the alert
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">alert id to delete</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> AlertsDeleteGetAsyncWithHttpInfo (string id);
        /// <summary>
        /// Get alerts for user account
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;Alerts&gt;</returns>
        System.Threading.Tasks.Task<List<Alerts>> AlertsGetAsync ();

        /// <summary>
        /// Get alerts for user account
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;Alerts&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Alerts>>> AlertsGetAsyncWithHttpInfo ();
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class AlertsApi : IAlertsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="AlertsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public AlertsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="AlertsApi"/> class
        /// </summary>
        /// <returns></returns>
        public AlertsApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="AlertsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public AlertsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.Options.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Edit or insert new alert 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the alert to edit ; if adding a new one leave blank</param>
        /// <param name="alertname">Name of the alert</param>
        /// <param name="activated">Should the alert be activated or not</param>
        /// <param name="type">Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category</param>
        /// <param name="channel">1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON</param>
        /// <param name="recipient">Email address of recipient or webhook for Slack/Gchat or JSON endpoint</param>
        /// <param name="param1">Parameter 1 (meaning changes with alert type) (optional)</param>
        /// <param name="param2">Parameter 2 (meaning changes with alert type) (optional)</param>
        /// <param name="param3">Parameter 3 (meaning changes with alert type) (optional)</param>
        /// <param name="param4">Parameter 4 (meaning changes with alert type) (optional)</param>
        /// <param name="param5">Parameter 5 (meaning changes with alert type) (optional)</param>
        /// <param name="param6">Parameter 6 (meaning changes with alert type) (optional)</param>
        /// <returns>List&lt;Domains&gt;</returns>
        public List<Domains> AlertsChangeGet (string id, string alertname, bool? activated, int? type, int? channel, string recipient, string param1 = null, string param2 = null, string param3 = null, string param4 = null, string param5 = null, string param6 = null)
        {
             ApiResponse<List<Domains>> localVarResponse = AlertsChangeGetWithHttpInfo(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5, param6);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Edit or insert new alert 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the alert to edit ; if adding a new one leave blank</param>
        /// <param name="alertname">Name of the alert</param>
        /// <param name="activated">Should the alert be activated or not</param>
        /// <param name="type">Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category</param>
        /// <param name="channel">1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON</param>
        /// <param name="recipient">Email address of recipient or webhook for Slack/Gchat or JSON endpoint</param>
        /// <param name="param1">Parameter 1 (meaning changes with alert type) (optional)</param>
        /// <param name="param2">Parameter 2 (meaning changes with alert type) (optional)</param>
        /// <param name="param3">Parameter 3 (meaning changes with alert type) (optional)</param>
        /// <param name="param4">Parameter 4 (meaning changes with alert type) (optional)</param>
        /// <param name="param5">Parameter 5 (meaning changes with alert type) (optional)</param>
        /// <param name="param6">Parameter 6 (meaning changes with alert type) (optional)</param>
        /// <returns>ApiResponse of List&lt;Domains&gt;</returns>
        public ApiResponse< List<Domains> > AlertsChangeGetWithHttpInfo (string id, string alertname, bool? activated, int? type, int? channel, string recipient, string param1 = null, string param2 = null, string param3 = null, string param4 = null, string param5 = null, string param6 = null)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling AlertsApi->AlertsChangeGet");
            // verify the required parameter 'alertname' is set
            if (alertname == null)
                throw new ApiException(400, "Missing required parameter 'alertname' when calling AlertsApi->AlertsChangeGet");
            // verify the required parameter 'activated' is set
            if (activated == null)
                throw new ApiException(400, "Missing required parameter 'activated' when calling AlertsApi->AlertsChangeGet");
            // verify the required parameter 'type' is set
            if (type == null)
                throw new ApiException(400, "Missing required parameter 'type' when calling AlertsApi->AlertsChangeGet");
            // verify the required parameter 'channel' is set
            if (channel == null)
                throw new ApiException(400, "Missing required parameter 'channel' when calling AlertsApi->AlertsChangeGet");
            // verify the required parameter 'recipient' is set
            if (recipient == null)
                throw new ApiException(400, "Missing required parameter 'recipient' when calling AlertsApi->AlertsChangeGet");

            var localVarPath = "/alerts_change";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (alertname != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "alertname", alertname)); // query parameter
            if (activated != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "activated", activated)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (channel != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "channel", channel)); // query parameter
            if (recipient != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "recipient", recipient)); // query parameter
            if (param1 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param1", param1)); // query parameter
            if (param2 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param2", param2)); // query parameter
            if (param3 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param3", param3)); // query parameter
            if (param4 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param4", param4)); // query parameter
            if (param5 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param5", param5)); // query parameter
            if (param6 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param6", param6)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AlertsChangeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Domains>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Domains>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Domains>)));
        }

        /// <summary>
        /// Edit or insert new alert 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the alert to edit ; if adding a new one leave blank</param>
        /// <param name="alertname">Name of the alert</param>
        /// <param name="activated">Should the alert be activated or not</param>
        /// <param name="type">Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category</param>
        /// <param name="channel">1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON</param>
        /// <param name="recipient">Email address of recipient or webhook for Slack/Gchat or JSON endpoint</param>
        /// <param name="param1">Parameter 1 (meaning changes with alert type) (optional)</param>
        /// <param name="param2">Parameter 2 (meaning changes with alert type) (optional)</param>
        /// <param name="param3">Parameter 3 (meaning changes with alert type) (optional)</param>
        /// <param name="param4">Parameter 4 (meaning changes with alert type) (optional)</param>
        /// <param name="param5">Parameter 5 (meaning changes with alert type) (optional)</param>
        /// <param name="param6">Parameter 6 (meaning changes with alert type) (optional)</param>
        /// <returns>Task of List&lt;Domains&gt;</returns>
        public async System.Threading.Tasks.Task<List<Domains>> AlertsChangeGetAsync (string id, string alertname, bool? activated, int? type, int? channel, string recipient, string param1 = null, string param2 = null, string param3 = null, string param4 = null, string param5 = null, string param6 = null)
        {
             ApiResponse<List<Domains>> localVarResponse = await AlertsChangeGetAsyncWithHttpInfo(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5, param6);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Edit or insert new alert 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the alert to edit ; if adding a new one leave blank</param>
        /// <param name="alertname">Name of the alert</param>
        /// <param name="activated">Should the alert be activated or not</param>
        /// <param name="type">Alert type (1&#x3D; New content for website, 2&#x3D;New performing contents), 3&#x3D;New contents in category</param>
        /// <param name="channel">1 for email, 2 for Slack, 3 for Google Chat, 4 for JSON</param>
        /// <param name="recipient">Email address of recipient or webhook for Slack/Gchat or JSON endpoint</param>
        /// <param name="param1">Parameter 1 (meaning changes with alert type) (optional)</param>
        /// <param name="param2">Parameter 2 (meaning changes with alert type) (optional)</param>
        /// <param name="param3">Parameter 3 (meaning changes with alert type) (optional)</param>
        /// <param name="param4">Parameter 4 (meaning changes with alert type) (optional)</param>
        /// <param name="param5">Parameter 5 (meaning changes with alert type) (optional)</param>
        /// <param name="param6">Parameter 6 (meaning changes with alert type) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Domains&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Domains>>> AlertsChangeGetAsyncWithHttpInfo (string id, string alertname, bool? activated, int? type, int? channel, string recipient, string param1 = null, string param2 = null, string param3 = null, string param4 = null, string param5 = null, string param6 = null)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling AlertsApi->AlertsChangeGet");
            // verify the required parameter 'alertname' is set
            if (alertname == null)
                throw new ApiException(400, "Missing required parameter 'alertname' when calling AlertsApi->AlertsChangeGet");
            // verify the required parameter 'activated' is set
            if (activated == null)
                throw new ApiException(400, "Missing required parameter 'activated' when calling AlertsApi->AlertsChangeGet");
            // verify the required parameter 'type' is set
            if (type == null)
                throw new ApiException(400, "Missing required parameter 'type' when calling AlertsApi->AlertsChangeGet");
            // verify the required parameter 'channel' is set
            if (channel == null)
                throw new ApiException(400, "Missing required parameter 'channel' when calling AlertsApi->AlertsChangeGet");
            // verify the required parameter 'recipient' is set
            if (recipient == null)
                throw new ApiException(400, "Missing required parameter 'recipient' when calling AlertsApi->AlertsChangeGet");

            var localVarPath = "/alerts_change";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (alertname != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "alertname", alertname)); // query parameter
            if (activated != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "activated", activated)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (channel != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "channel", channel)); // query parameter
            if (recipient != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "recipient", recipient)); // query parameter
            if (param1 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param1", param1)); // query parameter
            if (param2 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param2", param2)); // query parameter
            if (param3 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param3", param3)); // query parameter
            if (param4 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param4", param4)); // query parameter
            if (param5 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param5", param5)); // query parameter
            if (param6 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "param6", param6)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AlertsChangeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Domains>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Domains>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Domains>)));
        }

        /// <summary>
        /// Permanently delete the alert 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">alert id to delete</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        public List<TransactionInfo> AlertsDeleteGet (string id)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = AlertsDeleteGetWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Permanently delete the alert 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">alert id to delete</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        public ApiResponse< List<TransactionInfo> > AlertsDeleteGetWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling AlertsApi->AlertsDeleteGet");

            var localVarPath = "/alerts_delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AlertsDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Permanently delete the alert 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">alert id to delete</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<TransactionInfo>> AlertsDeleteGetAsync (string id)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = await AlertsDeleteGetAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Permanently delete the alert 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">alert id to delete</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> AlertsDeleteGetAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling AlertsApi->AlertsDeleteGet");

            var localVarPath = "/alerts_delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AlertsDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Get alerts for user account 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;Alerts&gt;</returns>
        public List<Alerts> AlertsGet ()
        {
             ApiResponse<List<Alerts>> localVarResponse = AlertsGetWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get alerts for user account 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;Alerts&gt;</returns>
        public ApiResponse< List<Alerts> > AlertsGetWithHttpInfo ()
        {

            var localVarPath = "/alerts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AlertsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Alerts>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Alerts>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Alerts>)));
        }

        /// <summary>
        /// Get alerts for user account 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;Alerts&gt;</returns>
        public async System.Threading.Tasks.Task<List<Alerts>> AlertsGetAsync ()
        {
             ApiResponse<List<Alerts>> localVarResponse = await AlertsGetAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get alerts for user account 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;Alerts&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Alerts>>> AlertsGetAsyncWithHttpInfo ()
        {

            var localVarPath = "/alerts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AlertsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Alerts>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Alerts>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Alerts>)));
        }

    }
}
