/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IFavsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Create a new fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        List<TransactionInfo> FavsAddGet (string name = null, string action = null, string parameters = null);

        /// <summary>
        /// Create a new fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        ApiResponse<List<TransactionInfo>> FavsAddGetWithHttpInfo (string name = null, string action = null, string parameters = null);
        /// <summary>
        /// Permanently delete the fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav to delete. (optional)</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        List<TransactionInfo> FavsDeleteGet (string id = null);

        /// <summary>
        /// Permanently delete the fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav to delete. (optional)</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        ApiResponse<List<TransactionInfo>> FavsDeleteGetWithHttpInfo (string id = null);
        /// <summary>
        /// Get favorites
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the requested fav. ignore or set to 0 to get the full favs list (optional)</param>
        /// <returns>List&lt;Favs&gt;</returns>
        List<Favs> FavsGet (string id = null);

        /// <summary>
        /// Get favorites
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the requested fav. ignore or set to 0 to get the full favs list (optional)</param>
        /// <returns>ApiResponse of List&lt;Favs&gt;</returns>
        ApiResponse<List<Favs>> FavsGetWithHttpInfo (string id = null);
        /// <summary>
        /// Update the fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav that should be edited</param>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <param name="scheduled">0 if not scheduled, else x in hours (optional)</param>
        /// <param name="scheduledto">email address of the recipient of this report (optional)</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        List<TransactionInfo> FavsUpdateGet (string id, string name = null, string action = null, string parameters = null, int? scheduled = null, string scheduledto = null);

        /// <summary>
        /// Update the fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav that should be edited</param>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <param name="scheduled">0 if not scheduled, else x in hours (optional)</param>
        /// <param name="scheduledto">email address of the recipient of this report (optional)</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        ApiResponse<List<TransactionInfo>> FavsUpdateGetWithHttpInfo (string id, string name = null, string action = null, string parameters = null, int? scheduled = null, string scheduledto = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Create a new fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        System.Threading.Tasks.Task<List<TransactionInfo>> FavsAddGetAsync (string name = null, string action = null, string parameters = null);

        /// <summary>
        /// Create a new fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> FavsAddGetAsyncWithHttpInfo (string name = null, string action = null, string parameters = null);
        /// <summary>
        /// Permanently delete the fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav to delete. (optional)</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        System.Threading.Tasks.Task<List<TransactionInfo>> FavsDeleteGetAsync (string id = null);

        /// <summary>
        /// Permanently delete the fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav to delete. (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> FavsDeleteGetAsyncWithHttpInfo (string id = null);
        /// <summary>
        /// Get favorites
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the requested fav. ignore or set to 0 to get the full favs list (optional)</param>
        /// <returns>Task of List&lt;Favs&gt;</returns>
        System.Threading.Tasks.Task<List<Favs>> FavsGetAsync (string id = null);

        /// <summary>
        /// Get favorites
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the requested fav. ignore or set to 0 to get the full favs list (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Favs&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Favs>>> FavsGetAsyncWithHttpInfo (string id = null);
        /// <summary>
        /// Update the fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav that should be edited</param>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <param name="scheduled">0 if not scheduled, else x in hours (optional)</param>
        /// <param name="scheduledto">email address of the recipient of this report (optional)</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        System.Threading.Tasks.Task<List<TransactionInfo>> FavsUpdateGetAsync (string id, string name = null, string action = null, string parameters = null, int? scheduled = null, string scheduledto = null);

        /// <summary>
        /// Update the fav
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav that should be edited</param>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <param name="scheduled">0 if not scheduled, else x in hours (optional)</param>
        /// <param name="scheduledto">email address of the recipient of this report (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> FavsUpdateGetAsyncWithHttpInfo (string id, string name = null, string action = null, string parameters = null, int? scheduled = null, string scheduledto = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class FavsApi : IFavsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="FavsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public FavsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="FavsApi"/> class
        /// </summary>
        /// <returns></returns>
        public FavsApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="FavsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public FavsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.Options.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Create a new fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        public List<TransactionInfo> FavsAddGet (string name = null, string action = null, string parameters = null)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = FavsAddGetWithHttpInfo(name, action, parameters);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        public ApiResponse< List<TransactionInfo> > FavsAddGetWithHttpInfo (string name = null, string action = null, string parameters = null)
        {

            var localVarPath = "/favs_add";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (action != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "action", action)); // query parameter
            if (parameters != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "parameters", parameters)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("FavsAddGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Create a new fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<TransactionInfo>> FavsAddGetAsync (string name = null, string action = null, string parameters = null)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = await FavsAddGetAsyncWithHttpInfo(name, action, parameters);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> FavsAddGetAsyncWithHttpInfo (string name = null, string action = null, string parameters = null)
        {

            var localVarPath = "/favs_add";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (action != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "action", action)); // query parameter
            if (parameters != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "parameters", parameters)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("FavsAddGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Permanently delete the fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav to delete. (optional)</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        public List<TransactionInfo> FavsDeleteGet (string id = null)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = FavsDeleteGetWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Permanently delete the fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav to delete. (optional)</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        public ApiResponse< List<TransactionInfo> > FavsDeleteGetWithHttpInfo (string id = null)
        {

            var localVarPath = "/favs_delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("FavsDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Permanently delete the fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav to delete. (optional)</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<TransactionInfo>> FavsDeleteGetAsync (string id = null)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = await FavsDeleteGetAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Permanently delete the fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav to delete. (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> FavsDeleteGetAsyncWithHttpInfo (string id = null)
        {

            var localVarPath = "/favs_delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("FavsDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Get favorites 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the requested fav. ignore or set to 0 to get the full favs list (optional)</param>
        /// <returns>List&lt;Favs&gt;</returns>
        public List<Favs> FavsGet (string id = null)
        {
             ApiResponse<List<Favs>> localVarResponse = FavsGetWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get favorites 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the requested fav. ignore or set to 0 to get the full favs list (optional)</param>
        /// <returns>ApiResponse of List&lt;Favs&gt;</returns>
        public ApiResponse< List<Favs> > FavsGetWithHttpInfo (string id = null)
        {

            var localVarPath = "/favs";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("FavsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Favs>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Favs>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Favs>)));
        }

        /// <summary>
        /// Get favorites 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the requested fav. ignore or set to 0 to get the full favs list (optional)</param>
        /// <returns>Task of List&lt;Favs&gt;</returns>
        public async System.Threading.Tasks.Task<List<Favs>> FavsGetAsync (string id = null)
        {
             ApiResponse<List<Favs>> localVarResponse = await FavsGetAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get favorites 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the requested fav. ignore or set to 0 to get the full favs list (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Favs&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Favs>>> FavsGetAsyncWithHttpInfo (string id = null)
        {

            var localVarPath = "/favs";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("FavsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Favs>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Favs>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Favs>)));
        }

        /// <summary>
        /// Update the fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav that should be edited</param>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <param name="scheduled">0 if not scheduled, else x in hours (optional)</param>
        /// <param name="scheduledto">email address of the recipient of this report (optional)</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        public List<TransactionInfo> FavsUpdateGet (string id, string name = null, string action = null, string parameters = null, int? scheduled = null, string scheduledto = null)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = FavsUpdateGetWithHttpInfo(id, name, action, parameters, scheduled, scheduledto);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update the fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav that should be edited</param>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <param name="scheduled">0 if not scheduled, else x in hours (optional)</param>
        /// <param name="scheduledto">email address of the recipient of this report (optional)</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        public ApiResponse< List<TransactionInfo> > FavsUpdateGetWithHttpInfo (string id, string name = null, string action = null, string parameters = null, int? scheduled = null, string scheduledto = null)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling FavsApi->FavsUpdateGet");

            var localVarPath = "/favs_update";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (action != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "action", action)); // query parameter
            if (parameters != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "parameters", parameters)); // query parameter
            if (scheduled != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "scheduled", scheduled)); // query parameter
            if (scheduledto != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "scheduledto", scheduledto)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("FavsUpdateGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Update the fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav that should be edited</param>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <param name="scheduled">0 if not scheduled, else x in hours (optional)</param>
        /// <param name="scheduledto">email address of the recipient of this report (optional)</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<TransactionInfo>> FavsUpdateGetAsync (string id, string name = null, string action = null, string parameters = null, int? scheduled = null, string scheduledto = null)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = await FavsUpdateGetAsyncWithHttpInfo(id, name, action, parameters, scheduled, scheduledto);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update the fav 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">ID of the fav that should be edited</param>
        /// <param name="name">Name of the fav. (optional)</param>
        /// <param name="action">Action to be opened. (optional)</param>
        /// <param name="parameters">Action&#x27;s parameters encoded in JSON. (optional)</param>
        /// <param name="scheduled">0 if not scheduled, else x in hours (optional)</param>
        /// <param name="scheduledto">email address of the recipient of this report (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> FavsUpdateGetAsyncWithHttpInfo (string id, string name = null, string action = null, string parameters = null, int? scheduled = null, string scheduledto = null)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling FavsApi->FavsUpdateGet");

            var localVarPath = "/favs_update";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (action != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "action", action)); // query parameter
            if (parameters != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "parameters", parameters)); // query parameter
            if (scheduled != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "scheduled", scheduled)); // query parameter
            if (scheduledto != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "scheduledto", scheduledto)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("FavsUpdateGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

    }
}
