/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IHistoricalApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get historical stats for categories
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to cateogry names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Categories&gt;</returns>
        List<Categories> CategoriesGet (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get historical stats for categories
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to cateogry names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Categories&gt;</returns>
        ApiResponse<List<Categories>> CategoriesGetWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null);
        /// <summary>
        /// Get history for category ID
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">category id</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>List&lt;Category&gt;</returns>
        List<Category> CategoryGet (string id, string country, string subcountry = null, string fromDate = null, string toDate = null);

        /// <summary>
        /// Get history for category ID
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">category id</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>ApiResponse of List&lt;Category&gt;</returns>
        ApiResponse<List<Category>> CategoryGetWithHttpInfo (string id, string country, string subcountry = null, string fromDate = null, string toDate = null);
        /// <summary>
        /// Get history for domain name
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">domain name (no subdomain allowed)</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>List&lt;Domain&gt;</returns>
        List<Domain> DomainGet (string domain, string country, string subcountry = null, string fromDate = null, string toDate = null);

        /// <summary>
        /// Get history for domain name
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">domain name (no subdomain allowed)</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>ApiResponse of List&lt;Domain&gt;</returns>
        ApiResponse<List<Domain>> DomainGetWithHttpInfo (string domain, string country, string subcountry = null, string fromDate = null, string toDate = null);
        /// <summary>
        /// Get historical stats for domains
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Domains&gt;</returns>
        List<Domains> DomainsGet (string country, string subcountry = null, string fromDate = null, string toDate = null, string urlFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get historical stats for domains
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Domains&gt;</returns>
        ApiResponse<List<Domains>> DomainsGetWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string urlFilter = null, int? lines = null, int? offset = null);
        /// <summary>
        /// Get historical stats for entities
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Entities&gt;</returns>
        List<Entities> EntitiesGet (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get historical stats for entities
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Entities&gt;</returns>
        ApiResponse<List<Entities>> EntitiesGetWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null);
        /// <summary>
        /// Get history for entity
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">entity exact name URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>List&lt;Entity&gt;</returns>
        List<Entity> EntityGet (string name, string country, string subcountry = null, string fromDate = null, string toDate = null);

        /// <summary>
        /// Get history for entity
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">entity exact name URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>ApiResponse of List&lt;Entity&gt;</returns>
        ApiResponse<List<Entity>> EntityGetWithHttpInfo (string name, string country, string subcountry = null, string fromDate = null, string toDate = null);
        /// <summary>
        /// Get page history for URL
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="url">Fully qualified page url. URL needs to be URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>List&lt;Page&gt;</returns>
        List<Page> PageGet (string url, string country, string subcountry = null, string fromDate = null, string toDate = null);

        /// <summary>
        /// Get page history for URL
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="url">Fully qualified page url. URL needs to be URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>ApiResponse of List&lt;Page&gt;</returns>
        ApiResponse<List<Page>> PageGetWithHttpInfo (string url, string country, string subcountry = null, string fromDate = null, string toDate = null);
        /// <summary>
        /// Get historical stats for pages
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="country">ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to a specific page category (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Pages&gt;</returns>
        List<Pages> PagesGet (string fromDate = null, string toDate = null, string country = null, string subcountry = null, int? presetFilter = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get historical stats for pages
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="country">ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to a specific page category (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Pages&gt;</returns>
        ApiResponse<List<Pages>> PagesGetWithHttpInfo (string fromDate = null, string toDate = null, string country = null, string subcountry = null, int? presetFilter = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get historical stats for categories
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to cateogry names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Categories&gt;</returns>
        System.Threading.Tasks.Task<List<Categories>> CategoriesGetAsync (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get historical stats for categories
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to cateogry names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Categories&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Categories>>> CategoriesGetAsyncWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null);
        /// <summary>
        /// Get history for category ID
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">category id</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of List&lt;Category&gt;</returns>
        System.Threading.Tasks.Task<List<Category>> CategoryGetAsync (string id, string country, string subcountry = null, string fromDate = null, string toDate = null);

        /// <summary>
        /// Get history for category ID
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">category id</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Category&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Category>>> CategoryGetAsyncWithHttpInfo (string id, string country, string subcountry = null, string fromDate = null, string toDate = null);
        /// <summary>
        /// Get history for domain name
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">domain name (no subdomain allowed)</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of List&lt;Domain&gt;</returns>
        System.Threading.Tasks.Task<List<Domain>> DomainGetAsync (string domain, string country, string subcountry = null, string fromDate = null, string toDate = null);

        /// <summary>
        /// Get history for domain name
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">domain name (no subdomain allowed)</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Domain&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Domain>>> DomainGetAsyncWithHttpInfo (string domain, string country, string subcountry = null, string fromDate = null, string toDate = null);
        /// <summary>
        /// Get historical stats for domains
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Domains&gt;</returns>
        System.Threading.Tasks.Task<List<Domains>> DomainsGetAsync (string country, string subcountry = null, string fromDate = null, string toDate = null, string urlFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get historical stats for domains
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Domains&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Domains>>> DomainsGetAsyncWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string urlFilter = null, int? lines = null, int? offset = null);
        /// <summary>
        /// Get historical stats for entities
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Entities&gt;</returns>
        System.Threading.Tasks.Task<List<Entities>> EntitiesGetAsync (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get historical stats for entities
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Entities&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Entities>>> EntitiesGetAsyncWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null);
        /// <summary>
        /// Get history for entity
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">entity exact name URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of List&lt;Entity&gt;</returns>
        System.Threading.Tasks.Task<List<Entity>> EntityGetAsync (string name, string country, string subcountry = null, string fromDate = null, string toDate = null);

        /// <summary>
        /// Get history for entity
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">entity exact name URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Entity&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Entity>>> EntityGetAsyncWithHttpInfo (string name, string country, string subcountry = null, string fromDate = null, string toDate = null);
        /// <summary>
        /// Get page history for URL
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="url">Fully qualified page url. URL needs to be URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of List&lt;Page&gt;</returns>
        System.Threading.Tasks.Task<List<Page>> PageGetAsync (string url, string country, string subcountry = null, string fromDate = null, string toDate = null);

        /// <summary>
        /// Get page history for URL
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="url">Fully qualified page url. URL needs to be URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Page&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Page>>> PageGetAsyncWithHttpInfo (string url, string country, string subcountry = null, string fromDate = null, string toDate = null);
        /// <summary>
        /// Get historical stats for pages
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="country">ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to a specific page category (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Pages&gt;</returns>
        System.Threading.Tasks.Task<List<Pages>> PagesGetAsync (string fromDate = null, string toDate = null, string country = null, string subcountry = null, int? presetFilter = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get historical stats for pages
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="country">ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to a specific page category (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Pages&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Pages>>> PagesGetAsyncWithHttpInfo (string fromDate = null, string toDate = null, string country = null, string subcountry = null, int? presetFilter = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class HistoricalApi : IHistoricalApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="HistoricalApi"/> class.
        /// </summary>
        /// <returns></returns>
        public HistoricalApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="HistoricalApi"/> class
        /// </summary>
        /// <returns></returns>
        public HistoricalApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="HistoricalApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public HistoricalApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.Options.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get historical stats for categories 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to cateogry names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Categories&gt;</returns>
        public List<Categories> CategoriesGet (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Categories>> localVarResponse = CategoriesGetWithHttpInfo(country, subcountry, fromDate, toDate, keywordFilter, lines, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get historical stats for categories 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to cateogry names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Categories&gt;</returns>
        public ApiResponse< List<Categories> > CategoriesGetWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->CategoriesGet");

            var localVarPath = "/categories";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CategoriesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Categories>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Categories>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Categories>)));
        }

        /// <summary>
        /// Get historical stats for categories 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to cateogry names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Categories&gt;</returns>
        public async System.Threading.Tasks.Task<List<Categories>> CategoriesGetAsync (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Categories>> localVarResponse = await CategoriesGetAsyncWithHttpInfo(country, subcountry, fromDate, toDate, keywordFilter, lines, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get historical stats for categories 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to cateogry names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Categories&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Categories>>> CategoriesGetAsyncWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->CategoriesGet");

            var localVarPath = "/categories";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CategoriesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Categories>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Categories>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Categories>)));
        }

        /// <summary>
        /// Get history for category ID 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">category id</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>List&lt;Category&gt;</returns>
        public List<Category> CategoryGet (string id, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
             ApiResponse<List<Category>> localVarResponse = CategoryGetWithHttpInfo(id, country, subcountry, fromDate, toDate);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get history for category ID 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">category id</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>ApiResponse of List&lt;Category&gt;</returns>
        public ApiResponse< List<Category> > CategoryGetWithHttpInfo (string id, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HistoricalApi->CategoryGet");
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->CategoryGet");

            var localVarPath = "/category";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CategoryGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Category>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Category>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Category>)));
        }

        /// <summary>
        /// Get history for category ID 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">category id</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of List&lt;Category&gt;</returns>
        public async System.Threading.Tasks.Task<List<Category>> CategoryGetAsync (string id, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
             ApiResponse<List<Category>> localVarResponse = await CategoryGetAsyncWithHttpInfo(id, country, subcountry, fromDate, toDate);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get history for category ID 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">category id</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Category&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Category>>> CategoryGetAsyncWithHttpInfo (string id, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HistoricalApi->CategoryGet");
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->CategoryGet");

            var localVarPath = "/category";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CategoryGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Category>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Category>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Category>)));
        }

        /// <summary>
        /// Get history for domain name 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">domain name (no subdomain allowed)</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>List&lt;Domain&gt;</returns>
        public List<Domain> DomainGet (string domain, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
             ApiResponse<List<Domain>> localVarResponse = DomainGetWithHttpInfo(domain, country, subcountry, fromDate, toDate);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get history for domain name 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">domain name (no subdomain allowed)</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>ApiResponse of List&lt;Domain&gt;</returns>
        public ApiResponse< List<Domain> > DomainGetWithHttpInfo (string domain, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
            // verify the required parameter 'domain' is set
            if (domain == null)
                throw new ApiException(400, "Missing required parameter 'domain' when calling HistoricalApi->DomainGet");
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->DomainGet");

            var localVarPath = "/domain";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (domain != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "domain", domain)); // query parameter
            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DomainGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Domain>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Domain>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Domain>)));
        }

        /// <summary>
        /// Get history for domain name 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">domain name (no subdomain allowed)</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of List&lt;Domain&gt;</returns>
        public async System.Threading.Tasks.Task<List<Domain>> DomainGetAsync (string domain, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
             ApiResponse<List<Domain>> localVarResponse = await DomainGetAsyncWithHttpInfo(domain, country, subcountry, fromDate, toDate);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get history for domain name 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="domain">domain name (no subdomain allowed)</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Domain&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Domain>>> DomainGetAsyncWithHttpInfo (string domain, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
            // verify the required parameter 'domain' is set
            if (domain == null)
                throw new ApiException(400, "Missing required parameter 'domain' when calling HistoricalApi->DomainGet");
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->DomainGet");

            var localVarPath = "/domain";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (domain != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "domain", domain)); // query parameter
            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DomainGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Domain>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Domain>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Domain>)));
        }

        /// <summary>
        /// Get historical stats for domains 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Domains&gt;</returns>
        public List<Domains> DomainsGet (string country, string subcountry = null, string fromDate = null, string toDate = null, string urlFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Domains>> localVarResponse = DomainsGetWithHttpInfo(country, subcountry, fromDate, toDate, urlFilter, lines, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get historical stats for domains 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Domains&gt;</returns>
        public ApiResponse< List<Domains> > DomainsGetWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string urlFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->DomainsGet");

            var localVarPath = "/domains";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            if (urlFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "url_filter", urlFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DomainsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Domains>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Domains>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Domains>)));
        }

        /// <summary>
        /// Get historical stats for domains 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Domains&gt;</returns>
        public async System.Threading.Tasks.Task<List<Domains>> DomainsGetAsync (string country, string subcountry = null, string fromDate = null, string toDate = null, string urlFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Domains>> localVarResponse = await DomainsGetAsyncWithHttpInfo(country, subcountry, fromDate, toDate, urlFilter, lines, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get historical stats for domains 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Domains&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Domains>>> DomainsGetAsyncWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string urlFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->DomainsGet");

            var localVarPath = "/domains";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            if (urlFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "url_filter", urlFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DomainsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Domains>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Domains>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Domains>)));
        }

        /// <summary>
        /// Get historical stats for entities 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Entities&gt;</returns>
        public List<Entities> EntitiesGet (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Entities>> localVarResponse = EntitiesGetWithHttpInfo(country, subcountry, fromDate, toDate, keywordFilter, lines, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get historical stats for entities 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Entities&gt;</returns>
        public ApiResponse< List<Entities> > EntitiesGetWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->EntitiesGet");

            var localVarPath = "/entities";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EntitiesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Entities>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Entities>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Entities>)));
        }

        /// <summary>
        /// Get historical stats for entities 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Entities&gt;</returns>
        public async System.Threading.Tasks.Task<List<Entities>> EntitiesGetAsync (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Entities>> localVarResponse = await EntitiesGetAsyncWithHttpInfo(country, subcountry, fromDate, toDate, keywordFilter, lines, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get historical stats for entities 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Entities&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Entities>>> EntitiesGetAsyncWithHttpInfo (string country, string subcountry = null, string fromDate = null, string toDate = null, string keywordFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->EntitiesGet");

            var localVarPath = "/entities";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EntitiesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Entities>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Entities>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Entities>)));
        }

        /// <summary>
        /// Get history for entity 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">entity exact name URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>List&lt;Entity&gt;</returns>
        public List<Entity> EntityGet (string name, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
             ApiResponse<List<Entity>> localVarResponse = EntityGetWithHttpInfo(name, country, subcountry, fromDate, toDate);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get history for entity 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">entity exact name URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>ApiResponse of List&lt;Entity&gt;</returns>
        public ApiResponse< List<Entity> > EntityGetWithHttpInfo (string name, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
            // verify the required parameter 'name' is set
            if (name == null)
                throw new ApiException(400, "Missing required parameter 'name' when calling HistoricalApi->EntityGet");
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->EntityGet");

            var localVarPath = "/entity";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EntityGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Entity>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Entity>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Entity>)));
        }

        /// <summary>
        /// Get history for entity 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">entity exact name URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of List&lt;Entity&gt;</returns>
        public async System.Threading.Tasks.Task<List<Entity>> EntityGetAsync (string name, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
             ApiResponse<List<Entity>> localVarResponse = await EntityGetAsyncWithHttpInfo(name, country, subcountry, fromDate, toDate);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get history for entity 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="name">entity exact name URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Entity&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Entity>>> EntityGetAsyncWithHttpInfo (string name, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
            // verify the required parameter 'name' is set
            if (name == null)
                throw new ApiException(400, "Missing required parameter 'name' when calling HistoricalApi->EntityGet");
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->EntityGet");

            var localVarPath = "/entity";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EntityGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Entity>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Entity>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Entity>)));
        }

        /// <summary>
        /// Get page history for URL 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="url">Fully qualified page url. URL needs to be URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>List&lt;Page&gt;</returns>
        public List<Page> PageGet (string url, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
             ApiResponse<List<Page>> localVarResponse = PageGetWithHttpInfo(url, country, subcountry, fromDate, toDate);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get page history for URL 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="url">Fully qualified page url. URL needs to be URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>ApiResponse of List&lt;Page&gt;</returns>
        public ApiResponse< List<Page> > PageGetWithHttpInfo (string url, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
            // verify the required parameter 'url' is set
            if (url == null)
                throw new ApiException(400, "Missing required parameter 'url' when calling HistoricalApi->PageGet");
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->PageGet");

            var localVarPath = "/page";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (url != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "url", url)); // query parameter
            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PageGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Page>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Page>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Page>)));
        }

        /// <summary>
        /// Get page history for URL 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="url">Fully qualified page url. URL needs to be URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of List&lt;Page&gt;</returns>
        public async System.Threading.Tasks.Task<List<Page>> PageGetAsync (string url, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
             ApiResponse<List<Page>> localVarResponse = await PageGetAsyncWithHttpInfo(url, country, subcountry, fromDate, toDate);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get page history for URL 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="url">Fully qualified page url. URL needs to be URL encoded</param>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Page&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Page>>> PageGetAsyncWithHttpInfo (string url, string country, string subcountry = null, string fromDate = null, string toDate = null)
        {
            // verify the required parameter 'url' is set
            if (url == null)
                throw new ApiException(400, "Missing required parameter 'url' when calling HistoricalApi->PageGet");
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling HistoricalApi->PageGet");

            var localVarPath = "/page";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (url != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "url", url)); // query parameter
            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PageGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Page>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Page>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Page>)));
        }

        /// <summary>
        /// Get historical stats for pages 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="country">ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to a specific page category (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Pages&gt;</returns>
        public List<Pages> PagesGet (string fromDate = null, string toDate = null, string country = null, string subcountry = null, int? presetFilter = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Pages>> localVarResponse = PagesGetWithHttpInfo(fromDate, toDate, country, subcountry, presetFilter, domainFilter, keywordFilter, entityFilter, urlFilter, categoryFilter, languageFilter, lines, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get historical stats for pages 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="country">ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to a specific page category (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Pages&gt;</returns>
        public ApiResponse< List<Pages> > PagesGetWithHttpInfo (string fromDate = null, string toDate = null, string country = null, string subcountry = null, int? presetFilter = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {

            var localVarPath = "/pages";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (presetFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "preset_filter", presetFilter)); // query parameter
            if (domainFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "domain_filter", domainFilter)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (entityFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "entity_filter", entityFilter)); // query parameter
            if (urlFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "url_filter", urlFilter)); // query parameter
            if (categoryFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "category_filter", categoryFilter)); // query parameter
            if (languageFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "language_filter", languageFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PagesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Pages>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Pages>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Pages>)));
        }

        /// <summary>
        /// Get historical stats for pages 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="country">ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to a specific page category (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Pages&gt;</returns>
        public async System.Threading.Tasks.Task<List<Pages>> PagesGetAsync (string fromDate = null, string toDate = null, string country = null, string subcountry = null, int? presetFilter = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Pages>> localVarResponse = await PagesGetAsyncWithHttpInfo(fromDate, toDate, country, subcountry, presetFilter, domainFilter, keywordFilter, entityFilter, urlFilter, categoryFilter, languageFilter, lines, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get historical stats for pages 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="fromDate">Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="toDate">Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)</param>
        /// <param name="country">ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter 1 no headlines 2 only headlines 3 to 6 deprecated 7 no articles 8 only articles 9 no shorts 10 only shorts 11 no showcase 12 only showcase 13 no video 14 only video 15 no webstory 16 only webstories (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to a specific page category (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 50000 a request with more than 50000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Pages&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Pages>>> PagesGetAsyncWithHttpInfo (string fromDate = null, string toDate = null, string country = null, string subcountry = null, int? presetFilter = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {

            var localVarPath = "/pages";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (fromDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "from_date", fromDate)); // query parameter
            if (toDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "to_date", toDate)); // query parameter
            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (presetFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "preset_filter", presetFilter)); // query parameter
            if (domainFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "domain_filter", domainFilter)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (entityFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "entity_filter", entityFilter)); // query parameter
            if (urlFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "url_filter", urlFilter)); // query parameter
            if (categoryFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "category_filter", categoryFilter)); // query parameter
            if (languageFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "language_filter", languageFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PagesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Pages>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Pages>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Pages>)));
        }

    }
}
