/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface ILiveApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get livedata stats for categories
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to category names containing a particular keyword (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Categories&gt;</returns>
        List<Categories> LivecategoriesGet (string country, string subcountry = null, int? hours = null, string keywordFilter = null, string languageFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get livedata stats for categories
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to category names containing a particular keyword (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Categories&gt;</returns>
        ApiResponse<List<Categories>> LivecategoriesGetWithHttpInfo (string country, string subcountry = null, int? hours = null, string keywordFilter = null, string languageFilter = null, int? lines = null, int? offset = null);
        /// <summary>
        /// Get livedata stats for domains
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Domains&gt;</returns>
        List<Domains> LivedomainsGet (string country, string subcountry = null, string urlFilter = null, int? hours = null, int? lines = null, string languageFilter = null, int? offset = null);

        /// <summary>
        /// Get livedata stats for domains
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Domains&gt;</returns>
        ApiResponse<List<Domains>> LivedomainsGetWithHttpInfo (string country, string subcountry = null, string urlFilter = null, int? hours = null, int? lines = null, string languageFilter = null, int? offset = null);
        /// <summary>
        /// Get livedata stats for entities
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Entities&gt;</returns>
        List<Entities> LiveentitiesGet (string country, string subcountry = null, int? hours = null, string keywordFilter = null, int? categoryFilter = null, string languageFilter = null, string domainFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get livedata stats for entities
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Entities&gt;</returns>
        ApiResponse<List<Entities>> LiveentitiesGetWithHttpInfo (string country, string subcountry = null, int? hours = null, string keywordFilter = null, int? categoryFilter = null, string languageFilter = null, string domainFilter = null, int? lines = null, int? offset = null);
        /// <summary>
        /// Get livedata stats for pages
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)</param>
        /// <param name="onlyNew">Get only pages first seen in the reporting period if set on 1 (optional, default to 0)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Pages&gt;</returns>
        List<Pages> LivepagesGet (string country, string subcountry = null, int? hours = null, int? presetFilter = null, int? onlyNew = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get livedata stats for pages
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)</param>
        /// <param name="onlyNew">Get only pages first seen in the reporting period if set on 1 (optional, default to 0)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Pages&gt;</returns>
        ApiResponse<List<Pages>> LivepagesGetWithHttpInfo (string country, string subcountry = null, int? hours = null, int? presetFilter = null, int? onlyNew = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get livedata stats for categories
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to category names containing a particular keyword (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Categories&gt;</returns>
        System.Threading.Tasks.Task<List<Categories>> LivecategoriesGetAsync (string country, string subcountry = null, int? hours = null, string keywordFilter = null, string languageFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get livedata stats for categories
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to category names containing a particular keyword (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Categories&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Categories>>> LivecategoriesGetAsyncWithHttpInfo (string country, string subcountry = null, int? hours = null, string keywordFilter = null, string languageFilter = null, int? lines = null, int? offset = null);
        /// <summary>
        /// Get livedata stats for domains
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Domains&gt;</returns>
        System.Threading.Tasks.Task<List<Domains>> LivedomainsGetAsync (string country, string subcountry = null, string urlFilter = null, int? hours = null, int? lines = null, string languageFilter = null, int? offset = null);

        /// <summary>
        /// Get livedata stats for domains
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Domains&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Domains>>> LivedomainsGetAsyncWithHttpInfo (string country, string subcountry = null, string urlFilter = null, int? hours = null, int? lines = null, string languageFilter = null, int? offset = null);
        /// <summary>
        /// Get livedata stats for entities
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Entities&gt;</returns>
        System.Threading.Tasks.Task<List<Entities>> LiveentitiesGetAsync (string country, string subcountry = null, int? hours = null, string keywordFilter = null, int? categoryFilter = null, string languageFilter = null, string domainFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get livedata stats for entities
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Entities&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Entities>>> LiveentitiesGetAsyncWithHttpInfo (string country, string subcountry = null, int? hours = null, string keywordFilter = null, int? categoryFilter = null, string languageFilter = null, string domainFilter = null, int? lines = null, int? offset = null);
        /// <summary>
        /// Get livedata stats for pages
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)</param>
        /// <param name="onlyNew">Get only pages first seen in the reporting period if set on 1 (optional, default to 0)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Pages&gt;</returns>
        System.Threading.Tasks.Task<List<Pages>> LivepagesGetAsync (string country, string subcountry = null, int? hours = null, int? presetFilter = null, int? onlyNew = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null);

        /// <summary>
        /// Get livedata stats for pages
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)</param>
        /// <param name="onlyNew">Get only pages first seen in the reporting period if set on 1 (optional, default to 0)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Pages&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Pages>>> LivepagesGetAsyncWithHttpInfo (string country, string subcountry = null, int? hours = null, int? presetFilter = null, int? onlyNew = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class LiveApi : ILiveApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="LiveApi"/> class.
        /// </summary>
        /// <returns></returns>
        public LiveApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="LiveApi"/> class
        /// </summary>
        /// <returns></returns>
        public LiveApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="LiveApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public LiveApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.Options.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get livedata stats for categories 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to category names containing a particular keyword (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Categories&gt;</returns>
        public List<Categories> LivecategoriesGet (string country, string subcountry = null, int? hours = null, string keywordFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Categories>> localVarResponse = LivecategoriesGetWithHttpInfo(country, subcountry, hours, keywordFilter, languageFilter, lines, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get livedata stats for categories 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to category names containing a particular keyword (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Categories&gt;</returns>
        public ApiResponse< List<Categories> > LivecategoriesGetWithHttpInfo (string country, string subcountry = null, int? hours = null, string keywordFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling LiveApi->LivecategoriesGet");

            var localVarPath = "/livecategories";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (hours != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "hours", hours)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (languageFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "language_filter", languageFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("LivecategoriesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Categories>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Categories>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Categories>)));
        }

        /// <summary>
        /// Get livedata stats for categories 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to category names containing a particular keyword (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Categories&gt;</returns>
        public async System.Threading.Tasks.Task<List<Categories>> LivecategoriesGetAsync (string country, string subcountry = null, int? hours = null, string keywordFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Categories>> localVarResponse = await LivecategoriesGetAsyncWithHttpInfo(country, subcountry, hours, keywordFilter, languageFilter, lines, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get livedata stats for categories 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to category names containing a particular keyword (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Categories&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Categories>>> LivecategoriesGetAsyncWithHttpInfo (string country, string subcountry = null, int? hours = null, string keywordFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling LiveApi->LivecategoriesGet");

            var localVarPath = "/livecategories";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (hours != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "hours", hours)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (languageFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "language_filter", languageFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("LivecategoriesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Categories>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Categories>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Categories>)));
        }

        /// <summary>
        /// Get livedata stats for domains 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Domains&gt;</returns>
        public List<Domains> LivedomainsGet (string country, string subcountry = null, string urlFilter = null, int? hours = null, int? lines = null, string languageFilter = null, int? offset = null)
        {
             ApiResponse<List<Domains>> localVarResponse = LivedomainsGetWithHttpInfo(country, subcountry, urlFilter, hours, lines, languageFilter, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get livedata stats for domains 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Domains&gt;</returns>
        public ApiResponse< List<Domains> > LivedomainsGetWithHttpInfo (string country, string subcountry = null, string urlFilter = null, int? hours = null, int? lines = null, string languageFilter = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling LiveApi->LivedomainsGet");

            var localVarPath = "/livedomains";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (urlFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "url_filter", urlFilter)); // query parameter
            if (hours != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "hours", hours)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (languageFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "language_filter", languageFilter)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("LivedomainsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Domains>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Domains>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Domains>)));
        }

        /// <summary>
        /// Get livedata stats for domains 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Domains&gt;</returns>
        public async System.Threading.Tasks.Task<List<Domains>> LivedomainsGetAsync (string country, string subcountry = null, string urlFilter = null, int? hours = null, int? lines = null, string languageFilter = null, int? offset = null)
        {
             ApiResponse<List<Domains>> localVarResponse = await LivedomainsGetAsyncWithHttpInfo(country, subcountry, urlFilter, hours, lines, languageFilter, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get livedata stats for domains 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="urlFilter">Filter answers to domains including a specified string (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Domains&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Domains>>> LivedomainsGetAsyncWithHttpInfo (string country, string subcountry = null, string urlFilter = null, int? hours = null, int? lines = null, string languageFilter = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling LiveApi->LivedomainsGet");

            var localVarPath = "/livedomains";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (urlFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "url_filter", urlFilter)); // query parameter
            if (hours != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "hours", hours)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (languageFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "language_filter", languageFilter)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("LivedomainsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Domains>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Domains>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Domains>)));
        }

        /// <summary>
        /// Get livedata stats for entities 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Entities&gt;</returns>
        public List<Entities> LiveentitiesGet (string country, string subcountry = null, int? hours = null, string keywordFilter = null, int? categoryFilter = null, string languageFilter = null, string domainFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Entities>> localVarResponse = LiveentitiesGetWithHttpInfo(country, subcountry, hours, keywordFilter, categoryFilter, languageFilter, domainFilter, lines, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get livedata stats for entities 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Entities&gt;</returns>
        public ApiResponse< List<Entities> > LiveentitiesGetWithHttpInfo (string country, string subcountry = null, int? hours = null, string keywordFilter = null, int? categoryFilter = null, string languageFilter = null, string domainFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling LiveApi->LiveentitiesGet");

            var localVarPath = "/liveentities";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (hours != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "hours", hours)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (categoryFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "category_filter", categoryFilter)); // query parameter
            if (languageFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "language_filter", languageFilter)); // query parameter
            if (domainFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "domain_filter", domainFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("LiveentitiesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Entities>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Entities>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Entities>)));
        }

        /// <summary>
        /// Get livedata stats for entities 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Entities&gt;</returns>
        public async System.Threading.Tasks.Task<List<Entities>> LiveentitiesGetAsync (string country, string subcountry = null, int? hours = null, string keywordFilter = null, int? categoryFilter = null, string languageFilter = null, string domainFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Entities>> localVarResponse = await LiveentitiesGetAsyncWithHttpInfo(country, subcountry, hours, keywordFilter, categoryFilter, languageFilter, domainFilter, lines, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get livedata stats for entities 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="keywordFilter">Filter answers to entity names containing a particular keyword (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 10000 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Entities&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Entities>>> LiveentitiesGetAsyncWithHttpInfo (string country, string subcountry = null, int? hours = null, string keywordFilter = null, int? categoryFilter = null, string languageFilter = null, string domainFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling LiveApi->LiveentitiesGet");

            var localVarPath = "/liveentities";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (hours != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "hours", hours)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (categoryFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "category_filter", categoryFilter)); // query parameter
            if (languageFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "language_filter", languageFilter)); // query parameter
            if (domainFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "domain_filter", domainFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("LiveentitiesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Entities>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Entities>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Entities>)));
        }

        /// <summary>
        /// Get livedata stats for pages 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)</param>
        /// <param name="onlyNew">Get only pages first seen in the reporting period if set on 1 (optional, default to 0)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>List&lt;Pages&gt;</returns>
        public List<Pages> LivepagesGet (string country, string subcountry = null, int? hours = null, int? presetFilter = null, int? onlyNew = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Pages>> localVarResponse = LivepagesGetWithHttpInfo(country, subcountry, hours, presetFilter, onlyNew, domainFilter, keywordFilter, entityFilter, urlFilter, categoryFilter, languageFilter, lines, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get livedata stats for pages 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)</param>
        /// <param name="onlyNew">Get only pages first seen in the reporting period if set on 1 (optional, default to 0)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>ApiResponse of List&lt;Pages&gt;</returns>
        public ApiResponse< List<Pages> > LivepagesGetWithHttpInfo (string country, string subcountry = null, int? hours = null, int? presetFilter = null, int? onlyNew = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling LiveApi->LivepagesGet");

            var localVarPath = "/livepages";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (hours != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "hours", hours)); // query parameter
            if (presetFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "preset_filter", presetFilter)); // query parameter
            if (onlyNew != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "only_new", onlyNew)); // query parameter
            if (domainFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "domain_filter", domainFilter)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (entityFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "entity_filter", entityFilter)); // query parameter
            if (urlFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "url_filter", urlFilter)); // query parameter
            if (categoryFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "category_filter", categoryFilter)); // query parameter
            if (languageFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "language_filter", languageFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("LivepagesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Pages>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Pages>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Pages>)));
        }

        /// <summary>
        /// Get livedata stats for pages 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)</param>
        /// <param name="onlyNew">Get only pages first seen in the reporting period if set on 1 (optional, default to 0)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of List&lt;Pages&gt;</returns>
        public async System.Threading.Tasks.Task<List<Pages>> LivepagesGetAsync (string country, string subcountry = null, int? hours = null, int? presetFilter = null, int? onlyNew = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {
             ApiResponse<List<Pages>> localVarResponse = await LivepagesGetAsyncWithHttpInfo(country, subcountry, hours, presetFilter, onlyNew, domainFilter, keywordFilter, entityFilter, urlFilter, categoryFilter, languageFilter, lines, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get livedata stats for pages 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="country">ISO_3166 country code in 2 letters</param>
        /// <param name="subcountry">state code (optional)</param>
        /// <param name="hours">Get results for last x hours (optional)</param>
        /// <param name="presetFilter">Apply preset filters &#x3D;&gt; 0 no filter, 1 no headlines, 2 only headlines, 3 to 6 deprecated, 7 no articles, 8 only articles, 9 no shorts, 10 only shorts, 11 no showcase, 12 only showcase, 13 no video, 14 only video, 15 no webstory, 16 only webstories (optional)</param>
        /// <param name="onlyNew">Get only pages first seen in the reporting period if set on 1 (optional, default to 0)</param>
        /// <param name="domainFilter">Filter answers to pages of a designated domain name (optional)</param>
        /// <param name="keywordFilter">Filter answers to pages titles containing a particular keyword (optional)</param>
        /// <param name="entityFilter">Filter answers to pages with entities containing a particular keyword (optional)</param>
        /// <param name="urlFilter">Filter answers to pages URL including a specified string (optional)</param>
        /// <param name="categoryFilter">Filter answers to pages of a designated category id (optional)</param>
        /// <param name="languageFilter">Filter answers to pages in specific user language (optional)</param>
        /// <param name="lines">Get X results (max in one request is 10000 a request with more than 10000 will be downgraded to 20 please use offset paginated results if you need more) (optional, default to 50)</param>
        /// <param name="offset">Get paginated results from X offset (optional, default to 0)</param>
        /// <returns>Task of ApiResponse (List&lt;Pages&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Pages>>> LivepagesGetAsyncWithHttpInfo (string country, string subcountry = null, int? hours = null, int? presetFilter = null, int? onlyNew = null, string domainFilter = null, string keywordFilter = null, string entityFilter = null, string urlFilter = null, int? categoryFilter = null, string languageFilter = null, int? lines = null, int? offset = null)
        {
            // verify the required parameter 'country' is set
            if (country == null)
                throw new ApiException(400, "Missing required parameter 'country' when calling LiveApi->LivepagesGet");

            var localVarPath = "/livepages";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (country != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "country", country)); // query parameter
            if (subcountry != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subcountry", subcountry)); // query parameter
            if (hours != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "hours", hours)); // query parameter
            if (presetFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "preset_filter", presetFilter)); // query parameter
            if (onlyNew != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "only_new", onlyNew)); // query parameter
            if (domainFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "domain_filter", domainFilter)); // query parameter
            if (keywordFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "keyword_filter", keywordFilter)); // query parameter
            if (entityFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "entity_filter", entityFilter)); // query parameter
            if (urlFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "url_filter", urlFilter)); // query parameter
            if (categoryFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "category_filter", categoryFilter)); // query parameter
            if (languageFilter != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "language_filter", languageFilter)); // query parameter
            if (lines != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lines", lines)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("LivepagesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Pages>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Pages>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Pages>)));
        }

    }
}
