/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IUserApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Change user&#x27;s activated countries
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="countries">json encoded string representing countries to activate</param>
        /// <param name="categories">json encoded string representing categories ID to activate</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        List<TransactionInfo> UserCountriesChangeGet (string countries, string categories);

        /// <summary>
        /// Change user&#x27;s activated countries
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="countries">json encoded string representing countries to activate</param>
        /// <param name="categories">json encoded string representing categories ID to activate</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        ApiResponse<List<TransactionInfo>> UserCountriesChangeGetWithHttpInfo (string countries, string categories);
        /// <summary>
        /// Change user customer id. This function is system reserved
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">new customer id for user</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        List<TransactionInfo> UserCustidChangeGet (string custid);

        /// <summary>
        /// Change user customer id. This function is system reserved
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">new customer id for user</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        ApiResponse<List<TransactionInfo>> UserCustidChangeGetWithHttpInfo (string custid);
        /// <summary>
        /// Permanently delete the user
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        List<TransactionInfo> UserDeleteGet ();

        /// <summary>
        /// Permanently delete the user
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        ApiResponse<List<TransactionInfo>> UserDeleteGetWithHttpInfo ();
        /// <summary>
        /// Change user details
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">new email address for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="translation">update the translation settings for user original (will show original titles) | english (will show titles translated in english) (optional)</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        List<TransactionInfo> UserDetailsChangeGet (string email, string fname, string lname, string translation = null);

        /// <summary>
        /// Change user details
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">new email address for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="translation">update the translation settings for user original (will show original titles) | english (will show titles translated in english) (optional)</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        ApiResponse<List<TransactionInfo>> UserDetailsChangeGetWithHttpInfo (string email, string fname, string lname, string translation = null);
        /// <summary>
        /// Login user with his credentials
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="pin">pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)</param>
        /// <returns>List&lt;UserInfo&gt;</returns>
        List<UserInfo> UserLoginGet (string email, string password, int? pin = null);

        /// <summary>
        /// Login user with his credentials
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="pin">pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)</param>
        /// <returns>ApiResponse of List&lt;UserInfo&gt;</returns>
        ApiResponse<List<UserInfo>> UserLoginGetWithHttpInfo (string email, string password, int? pin = null);
        /// <summary>
        /// Get messages for user
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="message">ID of the requested message. 0 to get the full message list (optional)</param>
        /// <returns>List&lt;Message&gt;</returns>
        List<Message> UserMessagesGet (int? message = null);

        /// <summary>
        /// Get messages for user
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="message">ID of the requested message. 0 to get the full message list (optional)</param>
        /// <returns>ApiResponse of List&lt;Message&gt;</returns>
        ApiResponse<List<Message>> UserMessagesGetWithHttpInfo (int? message = null);
        /// <summary>
        /// Change user password
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">current password for user</param>
        /// <param name="newpassword">new password to set up for user</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        List<TransactionInfo> UserPasswordChangeGet (string email, string password, string newpassword);

        /// <summary>
        /// Change user password
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">current password for user</param>
        /// <param name="newpassword">new password to set up for user</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        ApiResponse<List<TransactionInfo>> UserPasswordChangeGetWithHttpInfo (string email, string password, string newpassword);
        /// <summary>
        /// Reset user password
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        List<TransactionInfo> UserPasswordResetGet (string email);

        /// <summary>
        /// Reset user password
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        ApiResponse<List<TransactionInfo>> UserPasswordResetGetWithHttpInfo (string email);
        /// <summary>
        /// Refresh user rights with his Customer ID. This function is system reserved
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">Customer ID for the user</param>
        /// <returns>List&lt;UserInfo&gt;</returns>
        List<UserInfo> UserRefreshSubscriptionGet (string custid);

        /// <summary>
        /// Refresh user rights with his Customer ID. This function is system reserved
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">Customer ID for the user</param>
        /// <returns>ApiResponse of List&lt;UserInfo&gt;</returns>
        ApiResponse<List<UserInfo>> UserRefreshSubscriptionGetWithHttpInfo (string custid);
        /// <summary>
        /// Login user with his credentials
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="referrer">referrer for this user. should be urlencoded (optional)</param>
        /// <returns>List&lt;UserInfo&gt;</returns>
        List<UserInfo> UserRegisterGet (string email, string password, string fname, string lname, string referrer = null);

        /// <summary>
        /// Login user with his credentials
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="referrer">referrer for this user. should be urlencoded (optional)</param>
        /// <returns>ApiResponse of List&lt;UserInfo&gt;</returns>
        ApiResponse<List<UserInfo>> UserRegisterGetWithHttpInfo (string email, string password, string fname, string lname, string referrer = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Change user&#x27;s activated countries
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="countries">json encoded string representing countries to activate</param>
        /// <param name="categories">json encoded string representing categories ID to activate</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        System.Threading.Tasks.Task<List<TransactionInfo>> UserCountriesChangeGetAsync (string countries, string categories);

        /// <summary>
        /// Change user&#x27;s activated countries
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="countries">json encoded string representing countries to activate</param>
        /// <param name="categories">json encoded string representing categories ID to activate</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserCountriesChangeGetAsyncWithHttpInfo (string countries, string categories);
        /// <summary>
        /// Change user customer id. This function is system reserved
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">new customer id for user</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        System.Threading.Tasks.Task<List<TransactionInfo>> UserCustidChangeGetAsync (string custid);

        /// <summary>
        /// Change user customer id. This function is system reserved
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">new customer id for user</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserCustidChangeGetAsyncWithHttpInfo (string custid);
        /// <summary>
        /// Permanently delete the user
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        System.Threading.Tasks.Task<List<TransactionInfo>> UserDeleteGetAsync ();

        /// <summary>
        /// Permanently delete the user
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserDeleteGetAsyncWithHttpInfo ();
        /// <summary>
        /// Change user details
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">new email address for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="translation">update the translation settings for user original (will show original titles) | english (will show titles translated in english) (optional)</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        System.Threading.Tasks.Task<List<TransactionInfo>> UserDetailsChangeGetAsync (string email, string fname, string lname, string translation = null);

        /// <summary>
        /// Change user details
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">new email address for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="translation">update the translation settings for user original (will show original titles) | english (will show titles translated in english) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserDetailsChangeGetAsyncWithHttpInfo (string email, string fname, string lname, string translation = null);
        /// <summary>
        /// Login user with his credentials
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="pin">pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)</param>
        /// <returns>Task of List&lt;UserInfo&gt;</returns>
        System.Threading.Tasks.Task<List<UserInfo>> UserLoginGetAsync (string email, string password, int? pin = null);

        /// <summary>
        /// Login user with his credentials
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="pin">pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;UserInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<UserInfo>>> UserLoginGetAsyncWithHttpInfo (string email, string password, int? pin = null);
        /// <summary>
        /// Get messages for user
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="message">ID of the requested message. 0 to get the full message list (optional)</param>
        /// <returns>Task of List&lt;Message&gt;</returns>
        System.Threading.Tasks.Task<List<Message>> UserMessagesGetAsync (int? message = null);

        /// <summary>
        /// Get messages for user
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="message">ID of the requested message. 0 to get the full message list (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Message&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Message>>> UserMessagesGetAsyncWithHttpInfo (int? message = null);
        /// <summary>
        /// Change user password
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">current password for user</param>
        /// <param name="newpassword">new password to set up for user</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        System.Threading.Tasks.Task<List<TransactionInfo>> UserPasswordChangeGetAsync (string email, string password, string newpassword);

        /// <summary>
        /// Change user password
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">current password for user</param>
        /// <param name="newpassword">new password to set up for user</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserPasswordChangeGetAsyncWithHttpInfo (string email, string password, string newpassword);
        /// <summary>
        /// Reset user password
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        System.Threading.Tasks.Task<List<TransactionInfo>> UserPasswordResetGetAsync (string email);

        /// <summary>
        /// Reset user password
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserPasswordResetGetAsyncWithHttpInfo (string email);
        /// <summary>
        /// Refresh user rights with his Customer ID. This function is system reserved
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">Customer ID for the user</param>
        /// <returns>Task of List&lt;UserInfo&gt;</returns>
        System.Threading.Tasks.Task<List<UserInfo>> UserRefreshSubscriptionGetAsync (string custid);

        /// <summary>
        /// Refresh user rights with his Customer ID. This function is system reserved
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">Customer ID for the user</param>
        /// <returns>Task of ApiResponse (List&lt;UserInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<UserInfo>>> UserRefreshSubscriptionGetAsyncWithHttpInfo (string custid);
        /// <summary>
        /// Login user with his credentials
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="referrer">referrer for this user. should be urlencoded (optional)</param>
        /// <returns>Task of List&lt;UserInfo&gt;</returns>
        System.Threading.Tasks.Task<List<UserInfo>> UserRegisterGetAsync (string email, string password, string fname, string lname, string referrer = null);

        /// <summary>
        /// Login user with his credentials
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="referrer">referrer for this user. should be urlencoded (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;UserInfo&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<UserInfo>>> UserRegisterGetAsyncWithHttpInfo (string email, string password, string fname, string lname, string referrer = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class UserApi : IUserApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="UserApi"/> class.
        /// </summary>
        /// <returns></returns>
        public UserApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="UserApi"/> class
        /// </summary>
        /// <returns></returns>
        public UserApi()
        {
            this.Configuration = IO.Swagger.Client.Configuration.Default;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="UserApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public UserApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.Options.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Change user&#x27;s activated countries 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="countries">json encoded string representing countries to activate</param>
        /// <param name="categories">json encoded string representing categories ID to activate</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        public List<TransactionInfo> UserCountriesChangeGet (string countries, string categories)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = UserCountriesChangeGetWithHttpInfo(countries, categories);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Change user&#x27;s activated countries 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="countries">json encoded string representing countries to activate</param>
        /// <param name="categories">json encoded string representing categories ID to activate</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        public ApiResponse< List<TransactionInfo> > UserCountriesChangeGetWithHttpInfo (string countries, string categories)
        {
            // verify the required parameter 'countries' is set
            if (countries == null)
                throw new ApiException(400, "Missing required parameter 'countries' when calling UserApi->UserCountriesChangeGet");
            // verify the required parameter 'categories' is set
            if (categories == null)
                throw new ApiException(400, "Missing required parameter 'categories' when calling UserApi->UserCountriesChangeGet");

            var localVarPath = "/user_countries_change";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (countries != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "countries", countries)); // query parameter
            if (categories != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "categories", categories)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserCountriesChangeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Change user&#x27;s activated countries 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="countries">json encoded string representing countries to activate</param>
        /// <param name="categories">json encoded string representing categories ID to activate</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<TransactionInfo>> UserCountriesChangeGetAsync (string countries, string categories)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = await UserCountriesChangeGetAsyncWithHttpInfo(countries, categories);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Change user&#x27;s activated countries 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="countries">json encoded string representing countries to activate</param>
        /// <param name="categories">json encoded string representing categories ID to activate</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserCountriesChangeGetAsyncWithHttpInfo (string countries, string categories)
        {
            // verify the required parameter 'countries' is set
            if (countries == null)
                throw new ApiException(400, "Missing required parameter 'countries' when calling UserApi->UserCountriesChangeGet");
            // verify the required parameter 'categories' is set
            if (categories == null)
                throw new ApiException(400, "Missing required parameter 'categories' when calling UserApi->UserCountriesChangeGet");

            var localVarPath = "/user_countries_change";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (countries != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "countries", countries)); // query parameter
            if (categories != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "categories", categories)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserCountriesChangeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Change user customer id. This function is system reserved 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">new customer id for user</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        public List<TransactionInfo> UserCustidChangeGet (string custid)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = UserCustidChangeGetWithHttpInfo(custid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Change user customer id. This function is system reserved 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">new customer id for user</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        public ApiResponse< List<TransactionInfo> > UserCustidChangeGetWithHttpInfo (string custid)
        {
            // verify the required parameter 'custid' is set
            if (custid == null)
                throw new ApiException(400, "Missing required parameter 'custid' when calling UserApi->UserCustidChangeGet");

            var localVarPath = "/user_custid_change";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (custid != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "custid", custid)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserCustidChangeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Change user customer id. This function is system reserved 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">new customer id for user</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<TransactionInfo>> UserCustidChangeGetAsync (string custid)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = await UserCustidChangeGetAsyncWithHttpInfo(custid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Change user customer id. This function is system reserved 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">new customer id for user</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserCustidChangeGetAsyncWithHttpInfo (string custid)
        {
            // verify the required parameter 'custid' is set
            if (custid == null)
                throw new ApiException(400, "Missing required parameter 'custid' when calling UserApi->UserCustidChangeGet");

            var localVarPath = "/user_custid_change";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (custid != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "custid", custid)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserCustidChangeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Permanently delete the user 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        public List<TransactionInfo> UserDeleteGet ()
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = UserDeleteGetWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Permanently delete the user 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        public ApiResponse< List<TransactionInfo> > UserDeleteGetWithHttpInfo ()
        {

            var localVarPath = "/user_delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Permanently delete the user 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<TransactionInfo>> UserDeleteGetAsync ()
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = await UserDeleteGetAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Permanently delete the user 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserDeleteGetAsyncWithHttpInfo ()
        {

            var localVarPath = "/user_delete";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserDeleteGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Change user details 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">new email address for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="translation">update the translation settings for user original (will show original titles) | english (will show titles translated in english) (optional)</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        public List<TransactionInfo> UserDetailsChangeGet (string email, string fname, string lname, string translation = null)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = UserDetailsChangeGetWithHttpInfo(email, fname, lname, translation);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Change user details 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">new email address for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="translation">update the translation settings for user original (will show original titles) | english (will show titles translated in english) (optional)</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        public ApiResponse< List<TransactionInfo> > UserDetailsChangeGetWithHttpInfo (string email, string fname, string lname, string translation = null)
        {
            // verify the required parameter 'email' is set
            if (email == null)
                throw new ApiException(400, "Missing required parameter 'email' when calling UserApi->UserDetailsChangeGet");
            // verify the required parameter 'fname' is set
            if (fname == null)
                throw new ApiException(400, "Missing required parameter 'fname' when calling UserApi->UserDetailsChangeGet");
            // verify the required parameter 'lname' is set
            if (lname == null)
                throw new ApiException(400, "Missing required parameter 'lname' when calling UserApi->UserDetailsChangeGet");

            var localVarPath = "/user_details_change";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (fname != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "fname", fname)); // query parameter
            if (lname != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lname", lname)); // query parameter
            if (translation != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "translation", translation)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserDetailsChangeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Change user details 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">new email address for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="translation">update the translation settings for user original (will show original titles) | english (will show titles translated in english) (optional)</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<TransactionInfo>> UserDetailsChangeGetAsync (string email, string fname, string lname, string translation = null)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = await UserDetailsChangeGetAsyncWithHttpInfo(email, fname, lname, translation);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Change user details 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">new email address for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="translation">update the translation settings for user original (will show original titles) | english (will show titles translated in english) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserDetailsChangeGetAsyncWithHttpInfo (string email, string fname, string lname, string translation = null)
        {
            // verify the required parameter 'email' is set
            if (email == null)
                throw new ApiException(400, "Missing required parameter 'email' when calling UserApi->UserDetailsChangeGet");
            // verify the required parameter 'fname' is set
            if (fname == null)
                throw new ApiException(400, "Missing required parameter 'fname' when calling UserApi->UserDetailsChangeGet");
            // verify the required parameter 'lname' is set
            if (lname == null)
                throw new ApiException(400, "Missing required parameter 'lname' when calling UserApi->UserDetailsChangeGet");

            var localVarPath = "/user_details_change";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (fname != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "fname", fname)); // query parameter
            if (lname != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lname", lname)); // query parameter
            if (translation != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "translation", translation)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserDetailsChangeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Login user with his credentials 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="pin">pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)</param>
        /// <returns>List&lt;UserInfo&gt;</returns>
        public List<UserInfo> UserLoginGet (string email, string password, int? pin = null)
        {
             ApiResponse<List<UserInfo>> localVarResponse = UserLoginGetWithHttpInfo(email, password, pin);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Login user with his credentials 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="pin">pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)</param>
        /// <returns>ApiResponse of List&lt;UserInfo&gt;</returns>
        public ApiResponse< List<UserInfo> > UserLoginGetWithHttpInfo (string email, string password, int? pin = null)
        {
            // verify the required parameter 'email' is set
            if (email == null)
                throw new ApiException(400, "Missing required parameter 'email' when calling UserApi->UserLoginGet");
            // verify the required parameter 'password' is set
            if (password == null)
                throw new ApiException(400, "Missing required parameter 'password' when calling UserApi->UserLoginGet");

            var localVarPath = "/user_login";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (password != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "password", password)); // query parameter
            if (pin != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "pin", pin)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserLoginGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<UserInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<UserInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<UserInfo>)));
        }

        /// <summary>
        /// Login user with his credentials 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="pin">pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)</param>
        /// <returns>Task of List&lt;UserInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<UserInfo>> UserLoginGetAsync (string email, string password, int? pin = null)
        {
             ApiResponse<List<UserInfo>> localVarResponse = await UserLoginGetAsyncWithHttpInfo(email, password, pin);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Login user with his credentials 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="pin">pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;UserInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<UserInfo>>> UserLoginGetAsyncWithHttpInfo (string email, string password, int? pin = null)
        {
            // verify the required parameter 'email' is set
            if (email == null)
                throw new ApiException(400, "Missing required parameter 'email' when calling UserApi->UserLoginGet");
            // verify the required parameter 'password' is set
            if (password == null)
                throw new ApiException(400, "Missing required parameter 'password' when calling UserApi->UserLoginGet");

            var localVarPath = "/user_login";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (password != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "password", password)); // query parameter
            if (pin != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "pin", pin)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserLoginGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<UserInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<UserInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<UserInfo>)));
        }

        /// <summary>
        /// Get messages for user 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="message">ID of the requested message. 0 to get the full message list (optional)</param>
        /// <returns>List&lt;Message&gt;</returns>
        public List<Message> UserMessagesGet (int? message = null)
        {
             ApiResponse<List<Message>> localVarResponse = UserMessagesGetWithHttpInfo(message);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get messages for user 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="message">ID of the requested message. 0 to get the full message list (optional)</param>
        /// <returns>ApiResponse of List&lt;Message&gt;</returns>
        public ApiResponse< List<Message> > UserMessagesGetWithHttpInfo (int? message = null)
        {

            var localVarPath = "/user_messages";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (message != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "message", message)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserMessagesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Message>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Message>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Message>)));
        }

        /// <summary>
        /// Get messages for user 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="message">ID of the requested message. 0 to get the full message list (optional)</param>
        /// <returns>Task of List&lt;Message&gt;</returns>
        public async System.Threading.Tasks.Task<List<Message>> UserMessagesGetAsync (int? message = null)
        {
             ApiResponse<List<Message>> localVarResponse = await UserMessagesGetAsyncWithHttpInfo(message);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get messages for user 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="message">ID of the requested message. 0 to get the full message list (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Message&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Message>>> UserMessagesGetAsyncWithHttpInfo (int? message = null)
        {

            var localVarPath = "/user_messages";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (message != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "message", message)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserMessagesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Message>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<Message>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Message>)));
        }

        /// <summary>
        /// Change user password 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">current password for user</param>
        /// <param name="newpassword">new password to set up for user</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        public List<TransactionInfo> UserPasswordChangeGet (string email, string password, string newpassword)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = UserPasswordChangeGetWithHttpInfo(email, password, newpassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Change user password 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">current password for user</param>
        /// <param name="newpassword">new password to set up for user</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        public ApiResponse< List<TransactionInfo> > UserPasswordChangeGetWithHttpInfo (string email, string password, string newpassword)
        {
            // verify the required parameter 'email' is set
            if (email == null)
                throw new ApiException(400, "Missing required parameter 'email' when calling UserApi->UserPasswordChangeGet");
            // verify the required parameter 'password' is set
            if (password == null)
                throw new ApiException(400, "Missing required parameter 'password' when calling UserApi->UserPasswordChangeGet");
            // verify the required parameter 'newpassword' is set
            if (newpassword == null)
                throw new ApiException(400, "Missing required parameter 'newpassword' when calling UserApi->UserPasswordChangeGet");

            var localVarPath = "/user_password_change";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (password != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "password", password)); // query parameter
            if (newpassword != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "newpassword", newpassword)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserPasswordChangeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Change user password 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">current password for user</param>
        /// <param name="newpassword">new password to set up for user</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<TransactionInfo>> UserPasswordChangeGetAsync (string email, string password, string newpassword)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = await UserPasswordChangeGetAsyncWithHttpInfo(email, password, newpassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Change user password 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">current password for user</param>
        /// <param name="newpassword">new password to set up for user</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserPasswordChangeGetAsyncWithHttpInfo (string email, string password, string newpassword)
        {
            // verify the required parameter 'email' is set
            if (email == null)
                throw new ApiException(400, "Missing required parameter 'email' when calling UserApi->UserPasswordChangeGet");
            // verify the required parameter 'password' is set
            if (password == null)
                throw new ApiException(400, "Missing required parameter 'password' when calling UserApi->UserPasswordChangeGet");
            // verify the required parameter 'newpassword' is set
            if (newpassword == null)
                throw new ApiException(400, "Missing required parameter 'newpassword' when calling UserApi->UserPasswordChangeGet");

            var localVarPath = "/user_password_change";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (password != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "password", password)); // query parameter
            if (newpassword != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "newpassword", newpassword)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserPasswordChangeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Reset user password 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <returns>List&lt;TransactionInfo&gt;</returns>
        public List<TransactionInfo> UserPasswordResetGet (string email)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = UserPasswordResetGetWithHttpInfo(email);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Reset user password 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <returns>ApiResponse of List&lt;TransactionInfo&gt;</returns>
        public ApiResponse< List<TransactionInfo> > UserPasswordResetGetWithHttpInfo (string email)
        {
            // verify the required parameter 'email' is set
            if (email == null)
                throw new ApiException(400, "Missing required parameter 'email' when calling UserApi->UserPasswordResetGet");

            var localVarPath = "/user_password_reset";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserPasswordResetGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Reset user password 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <returns>Task of List&lt;TransactionInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<TransactionInfo>> UserPasswordResetGetAsync (string email)
        {
             ApiResponse<List<TransactionInfo>> localVarResponse = await UserPasswordResetGetAsyncWithHttpInfo(email);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Reset user password 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <returns>Task of ApiResponse (List&lt;TransactionInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<TransactionInfo>>> UserPasswordResetGetAsyncWithHttpInfo (string email)
        {
            // verify the required parameter 'email' is set
            if (email == null)
                throw new ApiException(400, "Missing required parameter 'email' when calling UserApi->UserPasswordResetGet");

            var localVarPath = "/user_password_reset";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserPasswordResetGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<TransactionInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<TransactionInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<TransactionInfo>)));
        }

        /// <summary>
        /// Refresh user rights with his Customer ID. This function is system reserved 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">Customer ID for the user</param>
        /// <returns>List&lt;UserInfo&gt;</returns>
        public List<UserInfo> UserRefreshSubscriptionGet (string custid)
        {
             ApiResponse<List<UserInfo>> localVarResponse = UserRefreshSubscriptionGetWithHttpInfo(custid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Refresh user rights with his Customer ID. This function is system reserved 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">Customer ID for the user</param>
        /// <returns>ApiResponse of List&lt;UserInfo&gt;</returns>
        public ApiResponse< List<UserInfo> > UserRefreshSubscriptionGetWithHttpInfo (string custid)
        {
            // verify the required parameter 'custid' is set
            if (custid == null)
                throw new ApiException(400, "Missing required parameter 'custid' when calling UserApi->UserRefreshSubscriptionGet");

            var localVarPath = "/user_refresh_subscription";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (custid != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "custid", custid)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserRefreshSubscriptionGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<UserInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<UserInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<UserInfo>)));
        }

        /// <summary>
        /// Refresh user rights with his Customer ID. This function is system reserved 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">Customer ID for the user</param>
        /// <returns>Task of List&lt;UserInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<UserInfo>> UserRefreshSubscriptionGetAsync (string custid)
        {
             ApiResponse<List<UserInfo>> localVarResponse = await UserRefreshSubscriptionGetAsyncWithHttpInfo(custid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Refresh user rights with his Customer ID. This function is system reserved 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="custid">Customer ID for the user</param>
        /// <returns>Task of ApiResponse (List&lt;UserInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<UserInfo>>> UserRefreshSubscriptionGetAsyncWithHttpInfo (string custid)
        {
            // verify the required parameter 'custid' is set
            if (custid == null)
                throw new ApiException(400, "Missing required parameter 'custid' when calling UserApi->UserRefreshSubscriptionGet");

            var localVarPath = "/user_refresh_subscription";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (custid != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "custid", custid)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserRefreshSubscriptionGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<UserInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<UserInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<UserInfo>)));
        }

        /// <summary>
        /// Login user with his credentials 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="referrer">referrer for this user. should be urlencoded (optional)</param>
        /// <returns>List&lt;UserInfo&gt;</returns>
        public List<UserInfo> UserRegisterGet (string email, string password, string fname, string lname, string referrer = null)
        {
             ApiResponse<List<UserInfo>> localVarResponse = UserRegisterGetWithHttpInfo(email, password, fname, lname, referrer);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Login user with his credentials 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="referrer">referrer for this user. should be urlencoded (optional)</param>
        /// <returns>ApiResponse of List&lt;UserInfo&gt;</returns>
        public ApiResponse< List<UserInfo> > UserRegisterGetWithHttpInfo (string email, string password, string fname, string lname, string referrer = null)
        {
            // verify the required parameter 'email' is set
            if (email == null)
                throw new ApiException(400, "Missing required parameter 'email' when calling UserApi->UserRegisterGet");
            // verify the required parameter 'password' is set
            if (password == null)
                throw new ApiException(400, "Missing required parameter 'password' when calling UserApi->UserRegisterGet");
            // verify the required parameter 'fname' is set
            if (fname == null)
                throw new ApiException(400, "Missing required parameter 'fname' when calling UserApi->UserRegisterGet");
            // verify the required parameter 'lname' is set
            if (lname == null)
                throw new ApiException(400, "Missing required parameter 'lname' when calling UserApi->UserRegisterGet");

            var localVarPath = "/user_register";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (password != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "password", password)); // query parameter
            if (fname != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "fname", fname)); // query parameter
            if (lname != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lname", lname)); // query parameter
            if (referrer != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "referrer", referrer)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserRegisterGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<UserInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<UserInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<UserInfo>)));
        }

        /// <summary>
        /// Login user with his credentials 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="referrer">referrer for this user. should be urlencoded (optional)</param>
        /// <returns>Task of List&lt;UserInfo&gt;</returns>
        public async System.Threading.Tasks.Task<List<UserInfo>> UserRegisterGetAsync (string email, string password, string fname, string lname, string referrer = null)
        {
             ApiResponse<List<UserInfo>> localVarResponse = await UserRegisterGetAsyncWithHttpInfo(email, password, fname, lname, referrer);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Login user with his credentials 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="email">email address for user</param>
        /// <param name="password">password for user</param>
        /// <param name="fname">new firstname for user</param>
        /// <param name="lname">new lastname for user</param>
        /// <param name="referrer">referrer for this user. should be urlencoded (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;UserInfo&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<UserInfo>>> UserRegisterGetAsyncWithHttpInfo (string email, string password, string fname, string lname, string referrer = null)
        {
            // verify the required parameter 'email' is set
            if (email == null)
                throw new ApiException(400, "Missing required parameter 'email' when calling UserApi->UserRegisterGet");
            // verify the required parameter 'password' is set
            if (password == null)
                throw new ApiException(400, "Missing required parameter 'password' when calling UserApi->UserRegisterGet");
            // verify the required parameter 'fname' is set
            if (fname == null)
                throw new ApiException(400, "Missing required parameter 'fname' when calling UserApi->UserRegisterGet");
            // verify the required parameter 'lname' is set
            if (lname == null)
                throw new ApiException(400, "Missing required parameter 'lname' when calling UserApi->UserRegisterGet");

            var localVarPath = "/user_register";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (password != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "password", password)); // query parameter
            if (fname != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "fname", fname)); // query parameter
            if (lname != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "lname", lname)); // query parameter
            if (referrer != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "referrer", referrer)); // query parameter
            // authentication (bearerAuth) required
            // bearer required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            RestResponse localVarResponse = (RestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.Get, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UserRegisterGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<UserInfo>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (List<UserInfo>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<UserInfo>)));
        }

    }
}
