/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;
namespace IO.Swagger.Model
{
    /// <summary>
    /// AlertCollection
    /// </summary>
    [DataContract]
        public partial class AlertCollection :  IEquatable<AlertCollection>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AlertCollection" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="createdAt">createdAt.</param>
        /// <param name="alertName">alertName.</param>
        /// <param name="activated">activated.</param>
        /// <param name="type">type.</param>
        /// <param name="channel">1 for email, 2 for Slack, 3 for Google Chat.</param>
        /// <param name="recipient">email address of recipient of webhooks for slack/google.</param>
        /// <param name="param1">param1.</param>
        /// <param name="param2">param2.</param>
        /// <param name="param3">param3.</param>
        /// <param name="param4">param4.</param>
        /// <param name="param5">param5.</param>
        /// <param name="param6">param6.</param>
        public AlertCollection(string id = default(string), string createdAt = default(string), string alertName = default(string), bool? activated = default(bool?), int? type = default(int?), int? channel = default(int?), string recipient = default(string), string param1 = default(string), string param2 = default(string), string param3 = default(string), string param4 = default(string), string param5 = default(string), string param6 = default(string))
        {
            this.Id = id;
            this.CreatedAt = createdAt;
            this.AlertName = alertName;
            this.Activated = activated;
            this.Type = type;
            this.Channel = channel;
            this.Recipient = recipient;
            this.Param1 = param1;
            this.Param2 = param2;
            this.Param3 = param3;
            this.Param4 = param4;
            this.Param5 = param5;
            this.Param6 = param6;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets CreatedAt
        /// </summary>
        [DataMember(Name="createdAt", EmitDefaultValue=false)]
        public string CreatedAt { get; set; }

        /// <summary>
        /// Gets or Sets AlertName
        /// </summary>
        [DataMember(Name="alertName", EmitDefaultValue=false)]
        public string AlertName { get; set; }

        /// <summary>
        /// Gets or Sets Activated
        /// </summary>
        [DataMember(Name="activated", EmitDefaultValue=false)]
        public bool? Activated { get; set; }

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public int? Type { get; set; }

        /// <summary>
        /// 1 for email, 2 for Slack, 3 for Google Chat
        /// </summary>
        /// <value>1 for email, 2 for Slack, 3 for Google Chat</value>
        [DataMember(Name="channel", EmitDefaultValue=false)]
        public int? Channel { get; set; }

        /// <summary>
        /// email address of recipient of webhooks for slack/google
        /// </summary>
        /// <value>email address of recipient of webhooks for slack/google</value>
        [DataMember(Name="recipient", EmitDefaultValue=false)]
        public string Recipient { get; set; }

        /// <summary>
        /// Gets or Sets Param1
        /// </summary>
        [DataMember(Name="param1", EmitDefaultValue=false)]
        public string Param1 { get; set; }

        /// <summary>
        /// Gets or Sets Param2
        /// </summary>
        [DataMember(Name="param2", EmitDefaultValue=false)]
        public string Param2 { get; set; }

        /// <summary>
        /// Gets or Sets Param3
        /// </summary>
        [DataMember(Name="param3", EmitDefaultValue=false)]
        public string Param3 { get; set; }

        /// <summary>
        /// Gets or Sets Param4
        /// </summary>
        [DataMember(Name="param4", EmitDefaultValue=false)]
        public string Param4 { get; set; }

        /// <summary>
        /// Gets or Sets Param5
        /// </summary>
        [DataMember(Name="param5", EmitDefaultValue=false)]
        public string Param5 { get; set; }

        /// <summary>
        /// Gets or Sets Param6
        /// </summary>
        [DataMember(Name="param6", EmitDefaultValue=false)]
        public string Param6 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AlertCollection {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  CreatedAt: ").Append(CreatedAt).Append("\n");
            sb.Append("  AlertName: ").Append(AlertName).Append("\n");
            sb.Append("  Activated: ").Append(Activated).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  Channel: ").Append(Channel).Append("\n");
            sb.Append("  Recipient: ").Append(Recipient).Append("\n");
            sb.Append("  Param1: ").Append(Param1).Append("\n");
            sb.Append("  Param2: ").Append(Param2).Append("\n");
            sb.Append("  Param3: ").Append(Param3).Append("\n");
            sb.Append("  Param4: ").Append(Param4).Append("\n");
            sb.Append("  Param5: ").Append(Param5).Append("\n");
            sb.Append("  Param6: ").Append(Param6).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AlertCollection);
        }

        /// <summary>
        /// Returns true if AlertCollection instances are equal
        /// </summary>
        /// <param name="input">Instance of AlertCollection to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AlertCollection input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.CreatedAt == input.CreatedAt ||
                    (this.CreatedAt != null &&
                    this.CreatedAt.Equals(input.CreatedAt))
                ) && 
                (
                    this.AlertName == input.AlertName ||
                    (this.AlertName != null &&
                    this.AlertName.Equals(input.AlertName))
                ) && 
                (
                    this.Activated == input.Activated ||
                    (this.Activated != null &&
                    this.Activated.Equals(input.Activated))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.Channel == input.Channel ||
                    (this.Channel != null &&
                    this.Channel.Equals(input.Channel))
                ) && 
                (
                    this.Recipient == input.Recipient ||
                    (this.Recipient != null &&
                    this.Recipient.Equals(input.Recipient))
                ) && 
                (
                    this.Param1 == input.Param1 ||
                    (this.Param1 != null &&
                    this.Param1.Equals(input.Param1))
                ) && 
                (
                    this.Param2 == input.Param2 ||
                    (this.Param2 != null &&
                    this.Param2.Equals(input.Param2))
                ) && 
                (
                    this.Param3 == input.Param3 ||
                    (this.Param3 != null &&
                    this.Param3.Equals(input.Param3))
                ) && 
                (
                    this.Param4 == input.Param4 ||
                    (this.Param4 != null &&
                    this.Param4.Equals(input.Param4))
                ) && 
                (
                    this.Param5 == input.Param5 ||
                    (this.Param5 != null &&
                    this.Param5.Equals(input.Param5))
                ) && 
                (
                    this.Param6 == input.Param6 ||
                    (this.Param6 != null &&
                    this.Param6.Equals(input.Param6))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.CreatedAt != null)
                    hashCode = hashCode * 59 + this.CreatedAt.GetHashCode();
                if (this.AlertName != null)
                    hashCode = hashCode * 59 + this.AlertName.GetHashCode();
                if (this.Activated != null)
                    hashCode = hashCode * 59 + this.Activated.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.Channel != null)
                    hashCode = hashCode * 59 + this.Channel.GetHashCode();
                if (this.Recipient != null)
                    hashCode = hashCode * 59 + this.Recipient.GetHashCode();
                if (this.Param1 != null)
                    hashCode = hashCode * 59 + this.Param1.GetHashCode();
                if (this.Param2 != null)
                    hashCode = hashCode * 59 + this.Param2.GetHashCode();
                if (this.Param3 != null)
                    hashCode = hashCode * 59 + this.Param3.GetHashCode();
                if (this.Param4 != null)
                    hashCode = hashCode * 59 + this.Param4.GetHashCode();
                if (this.Param5 != null)
                    hashCode = hashCode * 59 + this.Param5.GetHashCode();
                if (this.Param6 != null)
                    hashCode = hashCode * 59 + this.Param6.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
