/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;
namespace IO.Swagger.Model
{
    /// <summary>
    /// CategoriesCollection
    /// </summary>
    [DataContract]
        public partial class CategoriesCollection :  IEquatable<CategoriesCollection>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CategoriesCollection" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="isRoot">true if current category is a root category.</param>
        /// <param name="score">score.</param>
        /// <param name="position">position.</param>
        /// <param name="publications">publications.</param>
        public CategoriesCollection(int? id = default(int?), bool? isRoot = default(bool?), int? score = default(int?), int? position = default(int?), int? publications = default(int?))
        {
            this.Id = id;
            this.IsRoot = isRoot;
            this.Score = score;
            this.Position = position;
            this.Publications = publications;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public int? Id { get; set; }

        /// <summary>
        /// true if current category is a root category
        /// </summary>
        /// <value>true if current category is a root category</value>
        [DataMember(Name="is_root", EmitDefaultValue=false)]
        public bool? IsRoot { get; set; }

        /// <summary>
        /// Gets or Sets Score
        /// </summary>
        [DataMember(Name="score", EmitDefaultValue=false)]
        public int? Score { get; set; }

        /// <summary>
        /// Gets or Sets Position
        /// </summary>
        [DataMember(Name="position", EmitDefaultValue=false)]
        public int? Position { get; set; }

        /// <summary>
        /// Gets or Sets Publications
        /// </summary>
        [DataMember(Name="publications", EmitDefaultValue=false)]
        public int? Publications { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CategoriesCollection {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  IsRoot: ").Append(IsRoot).Append("\n");
            sb.Append("  Score: ").Append(Score).Append("\n");
            sb.Append("  Position: ").Append(Position).Append("\n");
            sb.Append("  Publications: ").Append(Publications).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CategoriesCollection);
        }

        /// <summary>
        /// Returns true if CategoriesCollection instances are equal
        /// </summary>
        /// <param name="input">Instance of CategoriesCollection to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CategoriesCollection input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.IsRoot == input.IsRoot ||
                    (this.IsRoot != null &&
                    this.IsRoot.Equals(input.IsRoot))
                ) && 
                (
                    this.Score == input.Score ||
                    (this.Score != null &&
                    this.Score.Equals(input.Score))
                ) && 
                (
                    this.Position == input.Position ||
                    (this.Position != null &&
                    this.Position.Equals(input.Position))
                ) && 
                (
                    this.Publications == input.Publications ||
                    (this.Publications != null &&
                    this.Publications.Equals(input.Publications))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.IsRoot != null)
                    hashCode = hashCode * 59 + this.IsRoot.GetHashCode();
                if (this.Score != null)
                    hashCode = hashCode * 59 + this.Score.GetHashCode();
                if (this.Position != null)
                    hashCode = hashCode * 59 + this.Position.GetHashCode();
                if (this.Publications != null)
                    hashCode = hashCode * 59 + this.Publications.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
