/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;
namespace IO.Swagger.Model
{
    /// <summary>
    /// CategoriesListCollection
    /// </summary>
    [DataContract]
        public partial class CategoriesListCollection :  IEquatable<CategoriesListCollection>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CategoriesListCollection" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="isRoot">true if current category is a root category.</param>
        /// <param name="name">name.</param>
        /// <param name="rootcategory">rootcategory.</param>
        public CategoriesListCollection(int? id = default(int?), bool? isRoot = default(bool?), string name = default(string), int? rootcategory = default(int?))
        {
            this.Id = id;
            this.IsRoot = isRoot;
            this.Name = name;
            this.Rootcategory = rootcategory;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public int? Id { get; set; }

        /// <summary>
        /// true if current category is a root category
        /// </summary>
        /// <value>true if current category is a root category</value>
        [DataMember(Name="is_root", EmitDefaultValue=false)]
        public bool? IsRoot { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets Rootcategory
        /// </summary>
        [DataMember(Name="rootcategory", EmitDefaultValue=false)]
        public int? Rootcategory { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CategoriesListCollection {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  IsRoot: ").Append(IsRoot).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Rootcategory: ").Append(Rootcategory).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CategoriesListCollection);
        }

        /// <summary>
        /// Returns true if CategoriesListCollection instances are equal
        /// </summary>
        /// <param name="input">Instance of CategoriesListCollection to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CategoriesListCollection input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.IsRoot == input.IsRoot ||
                    (this.IsRoot != null &&
                    this.IsRoot.Equals(input.IsRoot))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Rootcategory == input.Rootcategory ||
                    (this.Rootcategory != null &&
                    this.Rootcategory.Equals(input.Rootcategory))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.IsRoot != null)
                    hashCode = hashCode * 59 + this.IsRoot.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Rootcategory != null)
                    hashCode = hashCode * 59 + this.Rootcategory.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
