/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;
namespace IO.Swagger.Model
{
    /// <summary>
    /// CountriesListCollection
    /// </summary>
    [DataContract]
        public partial class CountriesListCollection :  IEquatable<CountriesListCollection>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CountriesListCollection" /> class.
        /// </summary>
        /// <param name="countryCode">countryCode.</param>
        /// <param name="name">name.</param>
        /// <param name="colour">html color code of the country.</param>
        /// <param name="flag">utf emoji representing the country flag.</param>
        /// <param name="population">country population in millions.</param>
        /// <param name="statsStartAt">date as YYYY-MM-DD after which DiscoverSnoop has data for the country.</param>
        public CountriesListCollection(string countryCode = default(string), string name = default(string), string colour = default(string), string flag = default(string), int? population = default(int?), string statsStartAt = default(string))
        {
            this.CountryCode = countryCode;
            this.Name = name;
            this.Colour = colour;
            this.Flag = flag;
            this.Population = population;
            this.StatsStartAt = statsStartAt;
        }
        
        /// <summary>
        /// Gets or Sets CountryCode
        /// </summary>
        [DataMember(Name="countryCode", EmitDefaultValue=false)]
        public string CountryCode { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// html color code of the country
        /// </summary>
        /// <value>html color code of the country</value>
        [DataMember(Name="colour", EmitDefaultValue=false)]
        public string Colour { get; set; }

        /// <summary>
        /// utf emoji representing the country flag
        /// </summary>
        /// <value>utf emoji representing the country flag</value>
        [DataMember(Name="flag", EmitDefaultValue=false)]
        public string Flag { get; set; }

        /// <summary>
        /// country population in millions
        /// </summary>
        /// <value>country population in millions</value>
        [DataMember(Name="population", EmitDefaultValue=false)]
        public int? Population { get; set; }

        /// <summary>
        /// date as YYYY-MM-DD after which DiscoverSnoop has data for the country
        /// </summary>
        /// <value>date as YYYY-MM-DD after which DiscoverSnoop has data for the country</value>
        [DataMember(Name="statsStartAt", EmitDefaultValue=false)]
        public string StatsStartAt { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CountriesListCollection {\n");
            sb.Append("  CountryCode: ").Append(CountryCode).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Colour: ").Append(Colour).Append("\n");
            sb.Append("  Flag: ").Append(Flag).Append("\n");
            sb.Append("  Population: ").Append(Population).Append("\n");
            sb.Append("  StatsStartAt: ").Append(StatsStartAt).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CountriesListCollection);
        }

        /// <summary>
        /// Returns true if CountriesListCollection instances are equal
        /// </summary>
        /// <param name="input">Instance of CountriesListCollection to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CountriesListCollection input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CountryCode == input.CountryCode ||
                    (this.CountryCode != null &&
                    this.CountryCode.Equals(input.CountryCode))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Colour == input.Colour ||
                    (this.Colour != null &&
                    this.Colour.Equals(input.Colour))
                ) && 
                (
                    this.Flag == input.Flag ||
                    (this.Flag != null &&
                    this.Flag.Equals(input.Flag))
                ) && 
                (
                    this.Population == input.Population ||
                    (this.Population != null &&
                    this.Population.Equals(input.Population))
                ) && 
                (
                    this.StatsStartAt == input.StatsStartAt ||
                    (this.StatsStartAt != null &&
                    this.StatsStartAt.Equals(input.StatsStartAt))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CountryCode != null)
                    hashCode = hashCode * 59 + this.CountryCode.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Colour != null)
                    hashCode = hashCode * 59 + this.Colour.GetHashCode();
                if (this.Flag != null)
                    hashCode = hashCode * 59 + this.Flag.GetHashCode();
                if (this.Population != null)
                    hashCode = hashCode * 59 + this.Population.GetHashCode();
                if (this.StatsStartAt != null)
                    hashCode = hashCode * 59 + this.StatsStartAt.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
