/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;
namespace IO.Swagger.Model
{
    /// <summary>
    /// DomainsCollection
    /// </summary>
    [DataContract]
        public partial class DomainsCollection :  IEquatable<DomainsCollection>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DomainsCollection" /> class.
        /// </summary>
        /// <param name="publisher">publisher.</param>
        /// <param name="publisherUrl">publisherUrl.</param>
        /// <param name="score">score.</param>
        /// <param name="position">position.</param>
        /// <param name="publications">publications.</param>
        /// <param name="firstviewed">firstviewed.</param>
        /// <param name="lastviewed">lastviewed.</param>
        /// <param name="isnews">this domain is whitelisted to publish in newsstories format.</param>
        /// <param name="ishealth">this domain is whitelisted to publish in /health category.</param>
        /// <param name="isfinance">this domain is whitelisted to publish in /finance format.</param>
        public DomainsCollection(string publisher = default(string), string publisherUrl = default(string), int? score = default(int?), int? position = default(int?), int? publications = default(int?), string firstviewed = default(string), string lastviewed = default(string), bool? isnews = default(bool?), bool? ishealth = default(bool?), bool? isfinance = default(bool?))
        {
            this.Publisher = publisher;
            this.PublisherUrl = publisherUrl;
            this.Score = score;
            this.Position = position;
            this.Publications = publications;
            this.Firstviewed = firstviewed;
            this.Lastviewed = lastviewed;
            this.Isnews = isnews;
            this.Ishealth = ishealth;
            this.Isfinance = isfinance;
        }
        
        /// <summary>
        /// Gets or Sets Publisher
        /// </summary>
        [DataMember(Name="publisher", EmitDefaultValue=false)]
        public string Publisher { get; set; }

        /// <summary>
        /// Gets or Sets PublisherUrl
        /// </summary>
        [DataMember(Name="publisher_url", EmitDefaultValue=false)]
        public string PublisherUrl { get; set; }

        /// <summary>
        /// Gets or Sets Score
        /// </summary>
        [DataMember(Name="score", EmitDefaultValue=false)]
        public int? Score { get; set; }

        /// <summary>
        /// Gets or Sets Position
        /// </summary>
        [DataMember(Name="position", EmitDefaultValue=false)]
        public int? Position { get; set; }

        /// <summary>
        /// Gets or Sets Publications
        /// </summary>
        [DataMember(Name="publications", EmitDefaultValue=false)]
        public int? Publications { get; set; }

        /// <summary>
        /// Gets or Sets Firstviewed
        /// </summary>
        [DataMember(Name="firstviewed", EmitDefaultValue=false)]
        public string Firstviewed { get; set; }

        /// <summary>
        /// Gets or Sets Lastviewed
        /// </summary>
        [DataMember(Name="lastviewed", EmitDefaultValue=false)]
        public string Lastviewed { get; set; }

        /// <summary>
        /// this domain is whitelisted to publish in newsstories format
        /// </summary>
        /// <value>this domain is whitelisted to publish in newsstories format</value>
        [DataMember(Name="isnews", EmitDefaultValue=false)]
        public bool? Isnews { get; set; }

        /// <summary>
        /// this domain is whitelisted to publish in /health category
        /// </summary>
        /// <value>this domain is whitelisted to publish in /health category</value>
        [DataMember(Name="ishealth", EmitDefaultValue=false)]
        public bool? Ishealth { get; set; }

        /// <summary>
        /// this domain is whitelisted to publish in /finance format
        /// </summary>
        /// <value>this domain is whitelisted to publish in /finance format</value>
        [DataMember(Name="isfinance", EmitDefaultValue=false)]
        public bool? Isfinance { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DomainsCollection {\n");
            sb.Append("  Publisher: ").Append(Publisher).Append("\n");
            sb.Append("  PublisherUrl: ").Append(PublisherUrl).Append("\n");
            sb.Append("  Score: ").Append(Score).Append("\n");
            sb.Append("  Position: ").Append(Position).Append("\n");
            sb.Append("  Publications: ").Append(Publications).Append("\n");
            sb.Append("  Firstviewed: ").Append(Firstviewed).Append("\n");
            sb.Append("  Lastviewed: ").Append(Lastviewed).Append("\n");
            sb.Append("  Isnews: ").Append(Isnews).Append("\n");
            sb.Append("  Ishealth: ").Append(Ishealth).Append("\n");
            sb.Append("  Isfinance: ").Append(Isfinance).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DomainsCollection);
        }

        /// <summary>
        /// Returns true if DomainsCollection instances are equal
        /// </summary>
        /// <param name="input">Instance of DomainsCollection to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DomainsCollection input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Publisher == input.Publisher ||
                    (this.Publisher != null &&
                    this.Publisher.Equals(input.Publisher))
                ) && 
                (
                    this.PublisherUrl == input.PublisherUrl ||
                    (this.PublisherUrl != null &&
                    this.PublisherUrl.Equals(input.PublisherUrl))
                ) && 
                (
                    this.Score == input.Score ||
                    (this.Score != null &&
                    this.Score.Equals(input.Score))
                ) && 
                (
                    this.Position == input.Position ||
                    (this.Position != null &&
                    this.Position.Equals(input.Position))
                ) && 
                (
                    this.Publications == input.Publications ||
                    (this.Publications != null &&
                    this.Publications.Equals(input.Publications))
                ) && 
                (
                    this.Firstviewed == input.Firstviewed ||
                    (this.Firstviewed != null &&
                    this.Firstviewed.Equals(input.Firstviewed))
                ) && 
                (
                    this.Lastviewed == input.Lastviewed ||
                    (this.Lastviewed != null &&
                    this.Lastviewed.Equals(input.Lastviewed))
                ) && 
                (
                    this.Isnews == input.Isnews ||
                    (this.Isnews != null &&
                    this.Isnews.Equals(input.Isnews))
                ) && 
                (
                    this.Ishealth == input.Ishealth ||
                    (this.Ishealth != null &&
                    this.Ishealth.Equals(input.Ishealth))
                ) && 
                (
                    this.Isfinance == input.Isfinance ||
                    (this.Isfinance != null &&
                    this.Isfinance.Equals(input.Isfinance))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Publisher != null)
                    hashCode = hashCode * 59 + this.Publisher.GetHashCode();
                if (this.PublisherUrl != null)
                    hashCode = hashCode * 59 + this.PublisherUrl.GetHashCode();
                if (this.Score != null)
                    hashCode = hashCode * 59 + this.Score.GetHashCode();
                if (this.Position != null)
                    hashCode = hashCode * 59 + this.Position.GetHashCode();
                if (this.Publications != null)
                    hashCode = hashCode * 59 + this.Publications.GetHashCode();
                if (this.Firstviewed != null)
                    hashCode = hashCode * 59 + this.Firstviewed.GetHashCode();
                if (this.Lastviewed != null)
                    hashCode = hashCode * 59 + this.Lastviewed.GetHashCode();
                if (this.Isnews != null)
                    hashCode = hashCode * 59 + this.Isnews.GetHashCode();
                if (this.Ishealth != null)
                    hashCode = hashCode * 59 + this.Ishealth.GetHashCode();
                if (this.Isfinance != null)
                    hashCode = hashCode * 59 + this.Isfinance.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
