/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;
namespace IO.Swagger.Model
{
    /// <summary>
    /// EntitiesCollection
    /// </summary>
    [DataContract]
        public partial class EntitiesCollection :  IEquatable<EntitiesCollection>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EntitiesCollection" /> class.
        /// </summary>
        /// <param name="entity">entity.</param>
        /// <param name="country">country.</param>
        /// <param name="score">score.</param>
        /// <param name="position">position.</param>
        /// <param name="publications">publications.</param>
        /// <param name="firstviewed">firstviewed.</param>
        /// <param name="lastviewed">lastviewed.</param>
        public EntitiesCollection(string entity = default(string), string country = default(string), int? score = default(int?), int? position = default(int?), int? publications = default(int?), string firstviewed = default(string), string lastviewed = default(string))
        {
            this.Entity = entity;
            this.Country = country;
            this.Score = score;
            this.Position = position;
            this.Publications = publications;
            this.Firstviewed = firstviewed;
            this.Lastviewed = lastviewed;
        }
        
        /// <summary>
        /// Gets or Sets Entity
        /// </summary>
        [DataMember(Name="entity", EmitDefaultValue=false)]
        public string Entity { get; set; }

        /// <summary>
        /// Gets or Sets Country
        /// </summary>
        [DataMember(Name="country", EmitDefaultValue=false)]
        public string Country { get; set; }

        /// <summary>
        /// Gets or Sets Score
        /// </summary>
        [DataMember(Name="score", EmitDefaultValue=false)]
        public int? Score { get; set; }

        /// <summary>
        /// Gets or Sets Position
        /// </summary>
        [DataMember(Name="position", EmitDefaultValue=false)]
        public int? Position { get; set; }

        /// <summary>
        /// Gets or Sets Publications
        /// </summary>
        [DataMember(Name="publications", EmitDefaultValue=false)]
        public int? Publications { get; set; }

        /// <summary>
        /// Gets or Sets Firstviewed
        /// </summary>
        [DataMember(Name="firstviewed", EmitDefaultValue=false)]
        public string Firstviewed { get; set; }

        /// <summary>
        /// Gets or Sets Lastviewed
        /// </summary>
        [DataMember(Name="lastviewed", EmitDefaultValue=false)]
        public string Lastviewed { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EntitiesCollection {\n");
            sb.Append("  Entity: ").Append(Entity).Append("\n");
            sb.Append("  Country: ").Append(Country).Append("\n");
            sb.Append("  Score: ").Append(Score).Append("\n");
            sb.Append("  Position: ").Append(Position).Append("\n");
            sb.Append("  Publications: ").Append(Publications).Append("\n");
            sb.Append("  Firstviewed: ").Append(Firstviewed).Append("\n");
            sb.Append("  Lastviewed: ").Append(Lastviewed).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EntitiesCollection);
        }

        /// <summary>
        /// Returns true if EntitiesCollection instances are equal
        /// </summary>
        /// <param name="input">Instance of EntitiesCollection to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EntitiesCollection input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Entity == input.Entity ||
                    (this.Entity != null &&
                    this.Entity.Equals(input.Entity))
                ) && 
                (
                    this.Country == input.Country ||
                    (this.Country != null &&
                    this.Country.Equals(input.Country))
                ) && 
                (
                    this.Score == input.Score ||
                    (this.Score != null &&
                    this.Score.Equals(input.Score))
                ) && 
                (
                    this.Position == input.Position ||
                    (this.Position != null &&
                    this.Position.Equals(input.Position))
                ) && 
                (
                    this.Publications == input.Publications ||
                    (this.Publications != null &&
                    this.Publications.Equals(input.Publications))
                ) && 
                (
                    this.Firstviewed == input.Firstviewed ||
                    (this.Firstviewed != null &&
                    this.Firstviewed.Equals(input.Firstviewed))
                ) && 
                (
                    this.Lastviewed == input.Lastviewed ||
                    (this.Lastviewed != null &&
                    this.Lastviewed.Equals(input.Lastviewed))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Entity != null)
                    hashCode = hashCode * 59 + this.Entity.GetHashCode();
                if (this.Country != null)
                    hashCode = hashCode * 59 + this.Country.GetHashCode();
                if (this.Score != null)
                    hashCode = hashCode * 59 + this.Score.GetHashCode();
                if (this.Position != null)
                    hashCode = hashCode * 59 + this.Position.GetHashCode();
                if (this.Publications != null)
                    hashCode = hashCode * 59 + this.Publications.GetHashCode();
                if (this.Firstviewed != null)
                    hashCode = hashCode * 59 + this.Firstviewed.GetHashCode();
                if (this.Lastviewed != null)
                    hashCode = hashCode * 59 + this.Lastviewed.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
