/* 
 * DiscoverSnoop
 *
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.250210
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;
namespace IO.Swagger.Model
{
    /// <summary>
    /// UserCollection
    /// </summary>
    [DataContract]
        public partial class UserCollection :  IEquatable<UserCollection>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="UserCollection" /> class.
        /// </summary>
        /// <param name="fname">fname.</param>
        /// <param name="lname">lname.</param>
        /// <param name="translation">translation.</param>
        /// <param name="email">email.</param>
        /// <param name="custid">custid.</param>
        /// <param name="plan">plan.</param>
        /// <param name="planDescription">planDescription.</param>
        /// <param name="countriesActivated">countriesActivated.</param>
        /// <param name="categoriesActivated">categoriesActivated.</param>
        /// <param name="countriesAllowed">countriesAllowed.</param>
        /// <param name="countriesOffered">countriesOffered.</param>
        /// <param name="countriesDaysToEdit">countriesDaysToEdit.</param>
        /// <param name="linesInReport">linesInReport.</param>
        /// <param name="alertsAllowed">alertsAllowed.</param>
        /// <param name="reportsAllowed">reportsAllowed.</param>
        /// <param name="apiAccess">apiAccess.</param>
        /// <param name="filterAccess">filterAccess.</param>
        /// <param name="apiToken">apiToken.</param>
        public UserCollection(string fname = default(string), string lname = default(string), string translation = default(string), string email = default(string), string custid = default(string), string plan = default(string), string planDescription = default(string), string countriesActivated = default(string), string categoriesActivated = default(string), int? countriesAllowed = default(int?), int? countriesOffered = default(int?), int? countriesDaysToEdit = default(int?), int? linesInReport = default(int?), int? alertsAllowed = default(int?), int? reportsAllowed = default(int?), int? apiAccess = default(int?), bool? filterAccess = default(bool?), string apiToken = default(string))
        {
            this.Fname = fname;
            this.Lname = lname;
            this.Translation = translation;
            this.Email = email;
            this.Custid = custid;
            this.Plan = plan;
            this.PlanDescription = planDescription;
            this.CountriesActivated = countriesActivated;
            this.CategoriesActivated = categoriesActivated;
            this.CountriesAllowed = countriesAllowed;
            this.CountriesOffered = countriesOffered;
            this.CountriesDaysToEdit = countriesDaysToEdit;
            this.LinesInReport = linesInReport;
            this.AlertsAllowed = alertsAllowed;
            this.ReportsAllowed = reportsAllowed;
            this.ApiAccess = apiAccess;
            this.FilterAccess = filterAccess;
            this.ApiToken = apiToken;
        }
        
        /// <summary>
        /// Gets or Sets Fname
        /// </summary>
        [DataMember(Name="fname", EmitDefaultValue=false)]
        public string Fname { get; set; }

        /// <summary>
        /// Gets or Sets Lname
        /// </summary>
        [DataMember(Name="lname", EmitDefaultValue=false)]
        public string Lname { get; set; }

        /// <summary>
        /// Gets or Sets Translation
        /// </summary>
        [DataMember(Name="translation", EmitDefaultValue=false)]
        public string Translation { get; set; }

        /// <summary>
        /// Gets or Sets Email
        /// </summary>
        [DataMember(Name="email", EmitDefaultValue=false)]
        public string Email { get; set; }

        /// <summary>
        /// Gets or Sets Custid
        /// </summary>
        [DataMember(Name="custid", EmitDefaultValue=false)]
        public string Custid { get; set; }

        /// <summary>
        /// Gets or Sets Plan
        /// </summary>
        [DataMember(Name="plan", EmitDefaultValue=false)]
        public string Plan { get; set; }

        /// <summary>
        /// Gets or Sets PlanDescription
        /// </summary>
        [DataMember(Name="plan_description", EmitDefaultValue=false)]
        public string PlanDescription { get; set; }

        /// <summary>
        /// Gets or Sets CountriesActivated
        /// </summary>
        [DataMember(Name="countries_activated", EmitDefaultValue=false)]
        public string CountriesActivated { get; set; }

        /// <summary>
        /// Gets or Sets CategoriesActivated
        /// </summary>
        [DataMember(Name="categories_activated", EmitDefaultValue=false)]
        public string CategoriesActivated { get; set; }

        /// <summary>
        /// Gets or Sets CountriesAllowed
        /// </summary>
        [DataMember(Name="countries_allowed", EmitDefaultValue=false)]
        public int? CountriesAllowed { get; set; }

        /// <summary>
        /// Gets or Sets CountriesOffered
        /// </summary>
        [DataMember(Name="countries_offered", EmitDefaultValue=false)]
        public int? CountriesOffered { get; set; }

        /// <summary>
        /// Gets or Sets CountriesDaysToEdit
        /// </summary>
        [DataMember(Name="countries_days_to_edit", EmitDefaultValue=false)]
        public int? CountriesDaysToEdit { get; set; }

        /// <summary>
        /// Gets or Sets LinesInReport
        /// </summary>
        [DataMember(Name="lines_in_report", EmitDefaultValue=false)]
        public int? LinesInReport { get; set; }

        /// <summary>
        /// Gets or Sets AlertsAllowed
        /// </summary>
        [DataMember(Name="alerts_allowed", EmitDefaultValue=false)]
        public int? AlertsAllowed { get; set; }

        /// <summary>
        /// Gets or Sets ReportsAllowed
        /// </summary>
        [DataMember(Name="reports_allowed", EmitDefaultValue=false)]
        public int? ReportsAllowed { get; set; }

        /// <summary>
        /// Gets or Sets ApiAccess
        /// </summary>
        [DataMember(Name="api_access", EmitDefaultValue=false)]
        public int? ApiAccess { get; set; }

        /// <summary>
        /// Gets or Sets FilterAccess
        /// </summary>
        [DataMember(Name="filter_access", EmitDefaultValue=false)]
        public bool? FilterAccess { get; set; }

        /// <summary>
        /// Gets or Sets ApiToken
        /// </summary>
        [DataMember(Name="api_token", EmitDefaultValue=false)]
        public string ApiToken { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class UserCollection {\n");
            sb.Append("  Fname: ").Append(Fname).Append("\n");
            sb.Append("  Lname: ").Append(Lname).Append("\n");
            sb.Append("  Translation: ").Append(Translation).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  Custid: ").Append(Custid).Append("\n");
            sb.Append("  Plan: ").Append(Plan).Append("\n");
            sb.Append("  PlanDescription: ").Append(PlanDescription).Append("\n");
            sb.Append("  CountriesActivated: ").Append(CountriesActivated).Append("\n");
            sb.Append("  CategoriesActivated: ").Append(CategoriesActivated).Append("\n");
            sb.Append("  CountriesAllowed: ").Append(CountriesAllowed).Append("\n");
            sb.Append("  CountriesOffered: ").Append(CountriesOffered).Append("\n");
            sb.Append("  CountriesDaysToEdit: ").Append(CountriesDaysToEdit).Append("\n");
            sb.Append("  LinesInReport: ").Append(LinesInReport).Append("\n");
            sb.Append("  AlertsAllowed: ").Append(AlertsAllowed).Append("\n");
            sb.Append("  ReportsAllowed: ").Append(ReportsAllowed).Append("\n");
            sb.Append("  ApiAccess: ").Append(ApiAccess).Append("\n");
            sb.Append("  FilterAccess: ").Append(FilterAccess).Append("\n");
            sb.Append("  ApiToken: ").Append(ApiToken).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as UserCollection);
        }

        /// <summary>
        /// Returns true if UserCollection instances are equal
        /// </summary>
        /// <param name="input">Instance of UserCollection to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(UserCollection input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Fname == input.Fname ||
                    (this.Fname != null &&
                    this.Fname.Equals(input.Fname))
                ) && 
                (
                    this.Lname == input.Lname ||
                    (this.Lname != null &&
                    this.Lname.Equals(input.Lname))
                ) && 
                (
                    this.Translation == input.Translation ||
                    (this.Translation != null &&
                    this.Translation.Equals(input.Translation))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                ) && 
                (
                    this.Custid == input.Custid ||
                    (this.Custid != null &&
                    this.Custid.Equals(input.Custid))
                ) && 
                (
                    this.Plan == input.Plan ||
                    (this.Plan != null &&
                    this.Plan.Equals(input.Plan))
                ) && 
                (
                    this.PlanDescription == input.PlanDescription ||
                    (this.PlanDescription != null &&
                    this.PlanDescription.Equals(input.PlanDescription))
                ) && 
                (
                    this.CountriesActivated == input.CountriesActivated ||
                    (this.CountriesActivated != null &&
                    this.CountriesActivated.Equals(input.CountriesActivated))
                ) && 
                (
                    this.CategoriesActivated == input.CategoriesActivated ||
                    (this.CategoriesActivated != null &&
                    this.CategoriesActivated.Equals(input.CategoriesActivated))
                ) && 
                (
                    this.CountriesAllowed == input.CountriesAllowed ||
                    (this.CountriesAllowed != null &&
                    this.CountriesAllowed.Equals(input.CountriesAllowed))
                ) && 
                (
                    this.CountriesOffered == input.CountriesOffered ||
                    (this.CountriesOffered != null &&
                    this.CountriesOffered.Equals(input.CountriesOffered))
                ) && 
                (
                    this.CountriesDaysToEdit == input.CountriesDaysToEdit ||
                    (this.CountriesDaysToEdit != null &&
                    this.CountriesDaysToEdit.Equals(input.CountriesDaysToEdit))
                ) && 
                (
                    this.LinesInReport == input.LinesInReport ||
                    (this.LinesInReport != null &&
                    this.LinesInReport.Equals(input.LinesInReport))
                ) && 
                (
                    this.AlertsAllowed == input.AlertsAllowed ||
                    (this.AlertsAllowed != null &&
                    this.AlertsAllowed.Equals(input.AlertsAllowed))
                ) && 
                (
                    this.ReportsAllowed == input.ReportsAllowed ||
                    (this.ReportsAllowed != null &&
                    this.ReportsAllowed.Equals(input.ReportsAllowed))
                ) && 
                (
                    this.ApiAccess == input.ApiAccess ||
                    (this.ApiAccess != null &&
                    this.ApiAccess.Equals(input.ApiAccess))
                ) && 
                (
                    this.FilterAccess == input.FilterAccess ||
                    (this.FilterAccess != null &&
                    this.FilterAccess.Equals(input.FilterAccess))
                ) && 
                (
                    this.ApiToken == input.ApiToken ||
                    (this.ApiToken != null &&
                    this.ApiToken.Equals(input.ApiToken))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Fname != null)
                    hashCode = hashCode * 59 + this.Fname.GetHashCode();
                if (this.Lname != null)
                    hashCode = hashCode * 59 + this.Lname.GetHashCode();
                if (this.Translation != null)
                    hashCode = hashCode * 59 + this.Translation.GetHashCode();
                if (this.Email != null)
                    hashCode = hashCode * 59 + this.Email.GetHashCode();
                if (this.Custid != null)
                    hashCode = hashCode * 59 + this.Custid.GetHashCode();
                if (this.Plan != null)
                    hashCode = hashCode * 59 + this.Plan.GetHashCode();
                if (this.PlanDescription != null)
                    hashCode = hashCode * 59 + this.PlanDescription.GetHashCode();
                if (this.CountriesActivated != null)
                    hashCode = hashCode * 59 + this.CountriesActivated.GetHashCode();
                if (this.CategoriesActivated != null)
                    hashCode = hashCode * 59 + this.CategoriesActivated.GetHashCode();
                if (this.CountriesAllowed != null)
                    hashCode = hashCode * 59 + this.CountriesAllowed.GetHashCode();
                if (this.CountriesOffered != null)
                    hashCode = hashCode * 59 + this.CountriesOffered.GetHashCode();
                if (this.CountriesDaysToEdit != null)
                    hashCode = hashCode * 59 + this.CountriesDaysToEdit.GetHashCode();
                if (this.LinesInReport != null)
                    hashCode = hashCode * 59 + this.LinesInReport.GetHashCode();
                if (this.AlertsAllowed != null)
                    hashCode = hashCode * 59 + this.AlertsAllowed.GetHashCode();
                if (this.ReportsAllowed != null)
                    hashCode = hashCode * 59 + this.ReportsAllowed.GetHashCode();
                if (this.ApiAccess != null)
                    hashCode = hashCode * 59 + this.ApiAccess.GetHashCode();
                if (this.FilterAccess != null)
                    hashCode = hashCode * 59 + this.FilterAccess.GetHashCode();
                if (this.ApiToken != null)
                    hashCode = hashCode * 59 + this.ApiToken.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
